Package: airpart
Title: Differential cell-type-specific allelic imbalance
Version: 1.19.0
Authors@R: 
    c(person(given = "Wancen",
           family = "Mu",
           role = c("aut", "cre"),
           email = "wancen@live.unc.edu",
           comment = c(ORCID = "0000-0002-5061-7581")),
    person(given = "Michael",
           family = "Love",
           role = c("aut", "ctb"),
           comment = c(ORCID = "0000-0001-8401-0545")))
Description: Airpart identifies sets of genes displaying differential
    cell-type-specific allelic imbalance across cell types
    or states, utilizing single-cell allelic counts. It makes use of a
    generalized fused lasso with binomial observations of allelic
    counts to partition cell types by their allelic
    imbalance. Alternatively, a nonparametric method for partitioning
    cell types is offered. The package includes a number of
    visualizations and quality control functions for examining single
    cell allelic imbalance datasets.
License: GPL-2
Depends: R (>= 4.1)
Imports: SingleCellExperiment, SummarizedExperiment, S4Vectors, scater,
        stats, smurf, apeglm (>= 1.13.3), emdbook, mclust, clue,
        dynamicTreeCut, matrixStats, dplyr, plyr, ggplot2,
        ComplexHeatmap, forestplot, RColorBrewer, rlang, lpSolve, grid,
        grDevices, graphics, utils, pbapply
Suggests: knitr, rmarkdown, roxygen2 (>= 6.0.0), testthat (>= 3.0.0),
        gplots, tidyr
VignetteBuilder: knitr
biocViews: SingleCell, RNASeq, ATACSeq, ChIPSeq, Sequencing,
        GeneRegulation, GeneExpression, Transcription,
        TranscriptomeVariant, CellBiology, FunctionalGenomics,
        DifferentialExpression, GraphAndNetwork, Regression,
        Clustering, QualityControl
Encoding: UTF-8
BugReports: https://github.com/Wancen/airpart/issues
URL: https://github.com/Wancen/airpart
RoxygenNote: 7.2.3
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/airpart
git_branch: devel
git_last_commit: b69681a
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-11-03
NeedsCompilation: no
Packaged: 2025-11-03 21:09:22 UTC; biocbuild
Author: Wancen Mu [aut, cre] (ORCID: <https://orcid.org/0000-0002-5061-7581>),
  Michael Love [aut, ctb] (ORCID:
    <https://orcid.org/0000-0001-8401-0545>)
Maintainer: Wancen Mu <wancen@live.unc.edu>

# airpart
Differential allelic imbalance partition across group of cells

![framwork](https://github.com/Wancen/airpartpaper/blob/main/framework.jpg)

# Install packages
```
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("airpart")
```

# Documentation
To view documentation for the version of this package installed in your system, start R and enter:
```
browseVignettes("airpart")
```

# Citation 
from within R, enter `citation("airpart")`:

Mu W, Sarkar H, Srivastava A, Choi K, Patro R, Love MI (2022). “Airpart: Interpretable statistical models for analyzing allelic imbalance in single-cell datasets.” Bioinformatics. doi: 10.1093/bioinformatics/btac212.

#' Gene clustering based on allelic ratio matrix with pseudo-count
#'
#' @param sce SingleCellExperiment containing assays \code{"ratio_pseudo"} and
#' colData factor \code{"x"}
#' @param method the method to do gene clustering. The default is the Gaussian
#' Mixture Modeling which
#' is likely to be more accurate. \code{"hierarchical"} represents
#' automatic hierarchical clustering which is faster to compute.
#' @param minClusterSize Minimum cluster size of \code{"hierarchical"} method.
#' @param plot logical, whether to make a PCA plot
#' @param G An integer vector specifying the numbers of clusters for which the
#' BIC is to be calculated.
#'  The default is G=c(8, 12, 16, 20, 24).
#' @param ... Catches unused arguments in indirect or list calls via do.call
#' as described in \code{\link[mclust]{Mclust}}
#'
#' @references
#'
#' This function leverages Mclust from the mclust package, or hclust.
#'
#' For mclust see:
#' Luca Scrucca and Michael Fop and T. Brendan Murphy, Adrian E. Raftery
#' "mclust 5: clustering, classification and density
#' estimation using {G}aussian finite mixture models"
#' 2016. The R Journal. doi: 10.32614/RJ-2016-021
#'
#' @seealso \code{\link[mclust]{Mclust}}
#'
#' @return gene cluster IDs are stored in the rowData column \code{cluster}
#' and a table of gene cluster is returned in metadata \code{geneCluster}
#'
#' @examples
#'
#' sce <- makeSimulatedData()
#' sce <- preprocess(sce)
#' sce <- geneCluster(sce, G = seq_len(4))
#' @importFrom mclust Mclust hc hcEII mclustBIC
#' @import ggplot2
#' @importFrom dynamicTreeCut cutreeDynamic
#' @importFrom stats prcomp hclust cutree dist as.dist median mad
#' @importFrom grDevices rainbow
#' @importFrom graphics par
#' @importFrom rlang .data
#'
#' @export
geneCluster <- function(sce, G, method = c("GMM", "hierarchical"),
                        minClusterSize = 3, plot = TRUE, ...) {
  method <- match.arg(method, c("GMM", "hierarchical"))
  if (missing(G)) {
    G <- c(8, 12, 16, 20, 24)
  }
  if (!"x" %in% names(colData(sce))) {
    stop('require a vector of annotated cell types "x" in colData')
  }
  if (!"ratio_pseudo" %in% assayNames(sce)) {
    stop('require an assay "ratio_pseudo"')
  }
  if (!is.factor(sce$x)) {
    sce$x <- as.factor(sce$x)
  }
  nct <- nlevels(sce$x)
  # PCA first
  pca <- prcomp(assays(sce)[["ratio_pseudo"]], rank. = 2 * nct) # use 2*nct
  ratio_pca <- as.matrix(pca$x)

  if (method == "GMM") {
    fit <- gmmCluster(ratio_pca, G, ...)
  } else if (method == "hierarchical") {
    fit <- hierCluster(ratio_pca, minClusterSize)
  }
  nclust <- fit$nclust
  my_clusters <- fit$my_clusters

  if (plot) {
    dat <- as.data.frame(ratio_pca)
    dat$GeneCluster <- factor(my_clusters)
    cols <- unname(rainbow(nclust + 1)[-1])
    p <- ggplot(dat, aes(.data$PC1, .data$PC2, col = .data$GeneCluster)) +
      geom_point() +
      scale_color_manual(values = cols) +
      theme_minimal()
    print(p)
  }

  rowData(sce)$cluster <- my_clusters
  metadata(sce)$geneCluster <- unname(table(my_clusters))
  return(sce)
}

gmmCluster <- function(ratio_pca, G, ...) {
  init <- list(hcPairs = mclust::hc(ratio_pca,
    modelName = "EII", use = "VARS"
  ))
  d_clust <- mclust::Mclust(ratio_pca,
    G = G, modelNames = "EII",
    initialization = init, ...
  )
  nclust <- dim(d_clust$z)[2]
  my_clusters <- unname(d_clust$classification)
  cat("model-based optimal number of clusters:", nclust, "\n")
  list(nclust = nclust, my_clusters = my_clusters)
}

hierCluster <- function(ratio_pca, minClusterSize) {
  my_dist <- dist(ratio_pca, method = "manhattan")
  my_tree <- hclust(my_dist, method = "ward.D2")
  my_clusters <- unname(
    cutreeDynamic(my_tree,
      distM = as.matrix(my_dist),
      verbose = 0, minClusterSize = minClusterSize
    )
  )
  nclust <- max(my_clusters)
  list(nclust = nclust, my_clusters = my_clusters)
}

library(S4Vectors)

test_that("wrong inputs", {

  # missed input arrays
  set.seed(2021)
  sce <- makeSimulatedData()
  expect_error(fusedLasso(sce, ncores = 1))

  # no genecluster identified
  sce <- preprocess(sce)
  expect_error(fusedLasso(sce, ncores = 1), "No gene cluster number")

  # no cluster column
  expect_error(fusedLasso(sce, model = "binomial", genecluster = 1, ncores = 1))

  # wrong cell state column names
  names(colData(sce)) <- "ct"
  expect_error(fusedLasso(sce, model = "binomial", genecluster = 1, ncores = 1))
})

test_that("basic fusedLasso analyses", {
  set.seed(2021)
  sce <- makeSimulatedData()
  sce <- preprocess(sce)
  sce <- geneCluster(sce, G = seq_len(4), plot = FALSE)
  sce_sub <- fusedLasso(sce, model = "binomial", genecluster = 1, ncores = 1)
  expect_true(is.numeric(metadata(sce_sub)$lambda))

  # gene and donor in formula
  colData(sce)$donor <- factor(rep(1:12, each=10))
  f <- ratio ~ p(x, pen = "gflasso") + gene + donor
  sce_sub <- fusedLasso(sce[1:5,], formula=f,
                        model = "binomial",
                        genecluster = 1, ncores = 1)
  expect_true(is.factor(metadata(sce_sub)$partition$part))
})

library(S4Vectors)

test_that("wrong inputs", {

  # missed input arrays
  set.seed(2021)
  sce <- makeSimulatedData()
  expect_error(wilcoxExt(sce))

  # require genecluster identified
  sce <- preprocess(sce)
  expect_error(wilcoxExt(sce), "No gene cluster number")

  # no cluster column
  expect_error(wilcoxExt(sce, genecluster = 1))

  # wrong cell state column names
  names(colData(sce)) <- "ct"
  expect_error(wilcoxExt(sce, genecluster = 1))
})

test_that("basic wilcox analyses", {
  set.seed(2021)
  sce <- makeSimulatedData()
  sce <- preprocess(sce)
  sce <- geneCluster(sce, G = seq_len(4), plot = FALSE)
  sce_sub <- wilcoxExt(sce, genecluster = 1)
  expect_true(is.numeric(metadata(sce_sub)$threshold))
})

library(S4Vectors)

test_that("check inputs", {

  # missing partition step
  set.seed(2021)
  sce <- makeSimulatedData()
  sce <- preprocess(sce)
  sce <- geneCluster(sce, G = seq_len(4))
  expect_error(allelicRatio(sce))
})

test_that("basic betabinom analyses", {
  set.seed(2021)
  sce <- makeSimulatedData()
  sce <- preprocess(sce)
  sce <- geneCluster(sce, G = seq_len(4))
  sce_sub <- wilcoxExt(sce, genecluster = 1)
  sce_sub <- allelicRatio(sce_sub)
  expect_true(!is.null(rowData(sce_sub)[, c(grep("ar", colnames(rowData(sce_sub)), value = TRUE))]))
})

#' Plot allelic ratio as heatmap
#'
#' @param sce SingleCellExperiment
#' @param assay the assay to be plotted. Choices are \code{"ratio_pseudo"} which is the default,
#' \code{"ratio"}, \code{"counts"}.
#' @param genecluster an integer indicates which gene cluster heatmap want to be returned.
#' @param show_row_names show row names or not
#' @param order_by_group indicate whether order by group or order by cell types
#' @param ... Passsed on the other argument in
#' \code{\link[ComplexHeatmap]{Heatmap}}.
#'
#' @return generates a heatmap
#'
#' @examples
#' set.seed(2021)
#' sce <- makeSimulatedData(p.vec = c(0.3, 0.5, 0.5, 0.3), ncl = 1)
#' sce <- preprocess(sce)
#' # display allelic ratio pattern in whole dataset
#' makeHeatmap(sce)
#'
#' sce <- geneCluster(sce, G = seq_len(4), plot = FALSE)
#' sce_sub <- wilcoxExt(sce, genecluster = 1)
#' # display specific gene cluster partition result
#' makeHeatmap(sce_sub)
#' # display by cell type orders
#' makeHeatmap(sce_sub, order_by_group = FALSE)
#' @importFrom ComplexHeatmap Heatmap HeatmapAnnotation anno_block
#' @importFrom RColorBrewer brewer.pal brewer.pal.info
#'
#' @export
makeHeatmap <- function(sce, assay = c("ratio_pseudo", "ratio", "counts"), genecluster = NULL,
                        show_row_names = FALSE, order_by_group = TRUE, ...) {
  stopifnot("x" %in% names(colData(sce)))
  assay <- match.arg(assay, c("ratio_pseudo", "ratio", "counts"))
  qual_col_pals <- brewer.pal.info[brewer.pal.info$category == "qual", ]
  col_vector <- unlist(mapply(brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  if (is.null(genecluster)) {
    m <- assays(sce)[[assay]]
  } else {
    m <- assays(sce[rowData(sce)$cluster == genecluster, ])[[assay]]
  }
  if (assay == "counts") {
    name <- "Total counts"
  } else {
    name <- "Allelic Ratio"
  }
  if (is.null(sce$part)) {
    split <- NULL
    ha <- ComplexHeatmap::HeatmapAnnotation(
      `cell type` = sce$x, border = FALSE,
      col = list(`cell type` = structure(col_vector[seq_len(nlevels(sce$x))],
        names = levels(sce$x)
      ))
    )
  } else {
    if (order_by_group) {
      split <- sce$part
      ha <- ComplexHeatmap::HeatmapAnnotation(
        group = anno_block(
          gp = gpar(fill = col_vector[seq_len(nlevels(split))]),
          labels_gp = gpar(col = "white", fontface = 4),
          labels = paste0("G", seq_len(nlevels(split)))
        ),
        `cell type` = sce$x, border = FALSE, group = sce$part,
        col = list(`cell type` = structure(col_vector[seq_len(nlevels(sce$x))],
          names = levels(sce$x)
        ))
      )
    } else {
      split0 <- rle(as.numeric(sce$part))
      y <- split0$lengths
      split <- rep(seq_along(y), y)
      ha <- ComplexHeatmap::HeatmapAnnotation(
        group = anno_block(
          gp = gpar(fill = col_vector[split0$values]),
          labels_gp = gpar(col = "white", fontface = 4),
          labels = paste0("G", split0$values)
        ),
        `cell type` = sce$x, border = FALSE,
        col = list(`cell type` = structure(col_vector[seq_len(nlevels(sce$x))],
          names = levels(sce$x)
        ))
      )
    }
  }
  ComplexHeatmap::Heatmap(m,
    column_split = split, column_title = NULL, top_annotation = ha,
    column_order = order(seq_len(ncol(m))), cluster_columns = FALSE,
    cluster_rows = FALSE, name = name,
    show_column_names = FALSE, show_row_names = show_row_names
  )
}

#' Generalized fused lasso to partition cell types by allelic imbalance
#'
#' Fits generalized fused lasso with either binomial(link="logit")
#' or Gaussian likelihood, leveraging functions from the
#' \code{smurf} package.
#'
#' @param sce A SingleCellExperiment containing assays (\code{"ratio"},
#' \code{"counts"}) and colData \code{"x"}
#' @param formula A \code{\link[stats]{formula}} object which will typically
#' involve a fused lasso penalty: default is just using cell-type `x`:
#' \code{ratio ~ p(x, pen="gflasso")}. Other possibilities would be to use
#' the Graph-Guided Fused Lasso penalty, or add covariates want to be
#' adjusted for, which can include a gene-level baseline `gene`
#' \code{ratio ~ p(x, pen = "ggflasso") + gene + batch}
#' See \code{\link[smurf]{glmsmurf}} for more details
#' @param model Either \code{"binomial"} or \code{"gaussian"} used to fit
#' the generalized fused lasso
#' @param genecluster which gene cluster to run the fused lasso on.
#' Usually one first identifies an interesting gene cluster pattern by
#' \code{\link{summaryAllelicRatio}}
#' @param niter number of iterations to run; recommended to run 5 times
#' if allelic ratio differences across cell types are within [0.05, 0.1]
#' @param pen.weights argument as described in \code{\link[smurf]{glmsmurf}}
#' @param lambda argument as described in \code{\link[smurf]{glmsmurf}}.
#' Default lambda is determined by \code{"cv1se.dev"}
#' (cross-validation within 1 standard error rule(SE); deviance)
#' @param k number of cross-validation folds
#' @param adj.matrix argument as described in \code{\link[smurf]{glmsmurf}}
#' @param lambda.length argument as described in \code{\link[smurf]{glmsmurf}}
#' @param se.rule.nct the number of cell types to trigger a different SE-based rule than 1 SE
#' (to prioritize larger models, less fusing,
#' good for detecting smaller, e.g. 0.05, allelic ratio differences).
#' When the number of cell types is less than or equal to this value,
#' \code{se.rule.mult} SE rule is used. When the number of cell types
#' is larger than this value, the standard 1 SE rule is used.
#' @param se.rule.mult the multiplier of the SE in determining the lambda:
#' the chosen lambda is within \code{se.rule.mult} x SE of the minimum deviance.
#' Small values will prioritize larger models, less fusing.
#' Only used when number of cell types is equal to or less than \code{se.rule.nct}
#' @param ... additional arguments passed to \code{\link[smurf]{glmsmurf}}
#'
#' @return A SummarizedExperiment with attached metadata and colData:
#' a matrix grouping factor partition
#' and the penalized parameter lambda
#' are returned in metadata \code{"partition"} and \code{"lambda"}.
#' Partition and logistic group allelic estimates are stored in
#' colData: \code{"part"} and \code{"coef"}.
#'
#' @details Usually, we used a Generalized Fused Lasso penalty for the
#' cell states in order to regularize all possible coefficient differences.
#' Another possibility would be to use the Graph-Guided Fused Lasso penalty
#' to only regularize the differences of coefficients of neighboring
#' cell states.
#'
#' When using a Graph-Guided Fused Lasso penalty, the adjacency matrix
#' corresponding to the graph needs to be provided. The elements of this
#' matrix are zero when two levels are not connected, and one when they are
#' adjacent.
#'
#' See the package vignette for more details and a complete description of a
#' use case.
#'
#' @references
#'
#' This function leverages the glmsmurf function from the smurf package.
#' For more details see the following manuscript:
#'
#' Devriendt S, Antonio K, Reynkens T, et al.
#' Sparse regression with multi-type regularized feature modeling[J].
#' Insurance: Mathematics and Economics, 2021, 96: 248-261.
#'
#' @seealso \code{\link[smurf]{glmsmurf}},
#' \code{\link[smurf]{glmsmurf.control}},
#' \code{\link[smurf]{p}}, \code{\link[stats]{glm}}
#'
#' @examples
#' library(S4Vectors)
#' library(smurf)
#' sce <- makeSimulatedData()
#' sce <- preprocess(sce)
#' sce <- geneCluster(sce, G = seq_len(4))
#' f <- ratio ~ p(x, pen = "gflasso") # formula for the GFL
#' sce_sub <- fusedLasso(sce,
#'   formula = f, model = "binomial", genecluster = 1, ncores = 1)
#' metadata(sce_sub)$partition
#' metadata(sce_sub)$lambda
#'
#' # can add covariates or `gene` to the formula
#' f2 <- ratio ~ p(x, pen = "gflasso") + gene
#' sce_sub <- fusedLasso(sce[1:5,],
#'   formula = f2, model = "binomial",
#'   genecluster = 1, ncores = 1)
#' 
#' # Suppose we have 4 cell states, if we only want neibouring cell states
#' # to be grouped together with other cell states. Note here the names of
#' # the cell states should be given as row and column names.
#' nct <- nlevels(sce$x)
#' adjmatrix <- makeOffByOneAdjMat(nct)
#' colnames(adjmatrix) <- rownames(adjmatrix) <- levels(sce$x)
#' f <- ratio ~ p(x, pen = "ggflasso") # use graph-guided fused lasso
#' sce_sub <- fusedLasso(sce,
#'   formula = f, model = "binomial", genecluster = 1,
#'   lambda = 0.5, ncores = 1,
#'   adj.matrix = list(x = adjmatrix)
#' )
#' metadata(sce_sub)$partition
#' @import smurf
#' @importFrom matrixStats rowSds
#' @importFrom stats binomial gaussian terms
#'
#' @export
fusedLasso <- function(sce, formula, model = c("binomial", "gaussian"),
                       genecluster,
                       niter = 1,
                       pen.weights, lambda = "cv1se.dev", k = 5,
                       adj.matrix, lambda.length = 25L,
                       se.rule.nct = 8,
                       se.rule.mult = 0.5,
                       ...) {
  model <- match.arg(model, c("binomial", "gaussian"))
  if (missing(genecluster)) stop("No gene cluster number")
  stopifnot(c("ratio", "counts") %in% assayNames(sce))
  stopifnot("x" %in% names(colData(sce)))
  stopifnot("cluster" %in% names(rowData(sce)))
  if (missing(formula)) {
    formula <- ratio ~ p(x, pen = "gflasso")
  }
  ## default is empty list
  if (missing(adj.matrix)) {
    adj.matrix <- list()
  }
  sce_sub <- sce[rowData(sce)$cluster == genecluster, ]
  cl_ratio <- as.vector(unlist(assays(sce_sub)[["ratio"]]))
  x_factor <- factor(rep(sce_sub$x, each = length(sce_sub)))
  cl_total <- as.vector(unlist(assays(sce_sub)[["counts"]]))
  gene <- factor(rep(seq_len(nrow(sce_sub)),times=ncol(sce_sub)))
  dat <- data.frame(
    ratio = cl_ratio,
    x = x_factor,
    cts = cl_total,
    gene = gene
  )
  index <- !is.nan(dat$ratio)
  dat <- dat[index, ]
  x <- model.matrix(~ x,dat)
  stopifnot(qr(x)$rank==ncol(x))
  # are there additional covariates besides x?
  add_covs <- grep("p\\(",
    attr(terms(formula), "term.labels"),
    invert = TRUE, value = TRUE
    )
  # adding covariates to `dat`, current this only supports factors
  if (length(add_covs) > 0) {
    for (v in setdiff(add_covs, "gene")) {
      dat[[v]] <- factor(rep(sce_sub[[v]], each=nrow(sce_sub)))[index]
      dat[[v]] <- droplevels(dat[[v]])
    }
  }
  
  if (model == "binomial") {
    fam <- binomial(link = "logit")
    msg <- "Failed determining max lambda, try other lambda, weights or gaussian model"
    weight <- dat$cts
  } else if (model == "gaussian") {
    fam <- gaussian()
    msg <- "Failed determining max of lambda, try other lambda or weights"
    weight <- NULL
  }
  nct <- nlevels(sce$x)
  ## need to use tryCatch to avoid lambda.max errors
  res <- tryCatch({
    sapply(seq_len(niter), function(t) {
      fitSmurf(
        t, formula, fam, dat, adj.matrix,
        weight, lambda, lambda.length, k,
        nct, se.rule.nct, se.rule.mult, ...)
    })
  }, error = function(e) {
    message(msg)
    return(NA)
  })
  if (length(res) == 1 && is.na(res)) {
    stop("Error occurred in attempting to run fused lasso")
  }
  if (niter == 1) {
    coef <- res[seq_len(nct), ]
    lambda <- unname(res[nrow(res), ])
    part <- match(coef, unique(coef)) %>% as.factor()
  } else {
    ## multiple partitions
    coef <- res[seq_len(nct), ]
    lambda <- res[nrow(res), ]
    part <- apply(coef, 2, function(z) match(z, unique(z)))
    colnames(part) <- paste0("part", seq_len(niter))
    colnames(coef) <- paste0("coef", seq_len(niter))
    names(lambda) <- paste0("part", seq_len(niter))
  }
  cl <- data.frame(part, x = levels(sce_sub$x), coef)
  colData(sce_sub)$part <- cl$part[match(colData(sce_sub)$x, cl$x)]
  colData(sce_sub)$coef <- cl$coef[match(colData(sce_sub)$x, cl$x)]
  metadata(sce_sub)$partition <- cl
  metadata(sce_sub)$lambda <- lambda
  sce_sub
}

fitSmurf <- function(t, formula, fam, dat, adj.matrix,
                     weight, lambda, lambda.length, k,
                     nct, se.rule.nct, se.rule.mult, ...) {
  fit <- smurf::glmsmurf(
    formula = formula, family = fam,
    data = dat, adj.matrix = adj.matrix,
    weights = weight,
    pen.weights = "glm.stand", lambda = lambda,
    control = list(lambda.length = lambda.length, k = k, ...)
  )
  co <- coef_reest(fit)
  co <- co + c(0, rep(co[1], nct - 1), rep(0, length(co) - nct))
  fit_lambda <- fit$lambda
  selection <- sub("\\..*", "", lambda)
  ## if number of cell types is 'se.rule.nct' or less:
  if (nct <= se.rule.nct & grepl("cv", selection)) {
    metric <- sub(".*\\.", "", lambda)
    ## choose lambda by the lowest deviance within 'se.rule.mult'
    ## standard error of the min
    mean.dev <- rowMeans(fit$lambda.measures[[metric]])
    min.dev <- min(mean.dev)
    sd.dev <- matrixStats::rowSds(fit$lambda.measures[[metric]])
    se.dev <- mean(sd.dev) / sqrt(k)
    idx <- which(mean.dev <= min.dev + se.rule.mult * se.dev)[1]
    ## this is faster, running the GFL for a single lambda value
    fit2 <- smurf::glmsmurf(
      formula = formula, family = fam,
      data = dat, adj.matrix = adj.matrix,
      weights = weight, pen.weights = "glm.stand",
      lambda = fit$lambda.vector[idx]
    )
    ## rearrange coefficients so not comparing to reference cell type
    co <- coef_reest(fit2)
    co <- co + c(0, rep(co[1], nct - 1), rep(0, length(co) - nct))
    fit_lambda <- fit2$lambda
  }
  ## stick the fitted means with the lambda on the end of the vector
  c(co, fit_lambda)
}


#' Generating adjancy matrix for neighboring cell states.
#'
#' To use the Graph-Guided Fused Lasso penalty to only regularize the differences
#' of coefficients of neighboring areas, suitable for time/spatial analysis.
#' The adjacency matrix corresponding to the graph needs to be provided.
#' The elements of this matrix are zero when two levels are not connected, and one when they are adjacent.
#'
#' @param nct the number of cell types/states
#' @details If manually input the adjacency matrix, this matrix has to be symmetric and the names of
#' the cell states should be given as row and column names.
#'
#' @examples
#' sce <- makeSimulatedData()
#' nct <- nlevels(sce$x)
#' adjmatrix <- makeOffByOneAdjMat(nct)
#' colnames(adjmatrix) <- rownames(adjmatrix) <- levels(sce$x)
#'
#' @export
makeOffByOneAdjMat <- function(nct) {
  b <- matrix(0, nct, nct)
  a <- diag(nct - 1)
  b[lower.tri(b, diag = FALSE)] <- a[lower.tri(a, diag = TRUE)]
  b + t(b)
}

#' Quality control on cells
#'
#' @param sce SingleCellExperiment with \code{counts} and \code{ratio}
#' @param spike the character name of spike genes.
#' If missing, \code{spikePercent} will all be zero and
#' \code{filter_spike} will be false.
#' @param threshold A numeric scalar specifying the threshold
#' above which a gene is considered to be detected.
#' @param mad_sum A numeric scalar specifying exceed
#' how many median absolute deviations
#' from the median log10-counts a cell is considered to be filtered out.
#' Default is 5.
#' @param mad_detected A numeric scalar specifying exceed
#' how many median absolute deviations
#' from the median detected features a cell is considered to be filtered out.
#' Default is 5.
#' @param mad_spikegenes A numeric scalar specifying exceed
#' how many median absolute deviations
#' from the median spike genes expression percentage a cell
#' is considered to be filtered out. Default is 5.
#'
#' @return A DataFrame of QC statistics includes
#' \itemize{
#'   \item{sum} {the sum of counts of each cell}
#'   \item{detected} {the number of features above \code{threshold}}
#'   \item{spikePercent} {the percentage of counts assignes to spike genes}
#'   \item{filter_sum} {indicate whether log10-counts
#'    within \code{mad_sum} median absolute deviations
#' from the median log10-counts for the dataset}
#'   \item{filter_detected} {indicate whether features detected by this cell
#'    within \code{mad_detected} median absolute deviations
#' from the median detected features for the dataset}
#'   \item{filter_spike} {indicate whether percentage expressed by spike genes
#'    within \code{mad_spikegenes} median absolute deviations from the median
#'    spike genes expression percentage for the dataset}
#'   }
#'
#' @examples
#' sce <- makeSimulatedData()
#' sce <- preprocess(sce)
#' cellQCmetrics <- cellQC(sce)
#' keep_cell <- (
#'   cellQCmetrics$filter_sum | # sufficient features (genes)
#'     # sufficient molecules counted
#'     cellQCmetrics$filter_detected |
#'     # sufficient features expressed compared to spike genes
#'     cellQCmetrics$filter_spike
#' )
#' sce <- sce[, keep_cell]
#'
#' # or manually setting threshold
#' cellQCmetrics <- cellQC(sce,
#'   spike = "Ercc",
#'   mad_detected = 4, mad_spikegenes = 4
#' )
#' keep_cell <- (
#'   cellQCmetrics$sum > 2.4 |
#'     cellQCmetrics$detected > 110
#' )
#' @importFrom SingleCellExperiment counts
#' @importFrom SummarizedExperiment colData colData<- rowData
#' rowData<- assayNames assays assays<-
#' @importFrom S4Vectors DataFrame metadata metadata<-
#'
#' @export
cellQC <- function(sce, spike, threshold = 0,
                   mad_sum = 5, mad_detected = 3, mad_spikegenes = 5) {
  keep_feature <- rowSums(counts(sce)) > 0
  sce <- sce[keep_feature, ]
  sum <- log10(colSums(counts(sce)))
  filter_sum <- (sum > (median(sum) - mad_sum * mad(sum)))

  detected <- colSums(counts(sce) > threshold)
  filter_detected <- (detected > (median(detected) -
    mad_detected * mad(detected)))
  if (missing(spike)) {
    spikePercent <- rep(0, ncol(sce))
    filter_spike <- rep(TRUE, ncol(sce))
  } else {
    spike_gene <- grep(spike, row.names(sce))
    if (length(spike_gene) == 0) {
      message("No spike genes found")
    }
    spikePercent <- colSums(counts(sce)[spike_gene, ], na.rm = TRUE) * 100 /
      colSums(counts(sce)[-spike_gene, ], na.rm = TRUE)
    filter_spike <- (spikePercent > (median(spikePercent) -
      mad_spikegenes * mad(spikePercent)) &
      spikePercent < (median(spikePercent) +
        mad_spikegenes * mad(spikePercent)))
  }

  coldata <- cbind(
    colData(sce), sum, detected, spikePercent,
    filter_sum, filter_detected, filter_spike
  )
  coldata
}

#' Quality control on features
#'
#' @param sce SingleCellExperiment with \code{counts} and \code{ratio}
#' @param spike the character name of spike genes. The default is \code{Ercc}
#' @param detection_limit Numeric scalar providing the value above which
#' observations are deemed to be expressed.
#' @param threshold A numeric scalar specifying the threshold above which
#' percentage of cells expressed within each cell type. Default is 0.25
#' @param sd A numeric scalar specifying the cell type weighted
#' allelic ratio mean standard deviation threshold
#' above which are interested features with highly variation. Default is 0.03
#' @param pc pseudocount in the \code{preprocess} step
#'
#' @return A DataFrame of QC statistics includes
#' \itemize{
#'   \item{filter_celltype} {indicate whether genes expressed in more than
#' \code{threshold} cells for all cell types}
#'   \item{sd} {read counts standard deviation for each feature}
#'   \item{filter_sd} {indicate whether gene standard deviation
#' exceed \code{sd}}
#'   \item{filter_spike} {indicate no spike genes}
#'   }
#'
#' @examples
#'
#' sce <- makeSimulatedData()
#' sce <- preprocess(sce)
#' featureQCmetric <- featureQC(sce)
#' keep_feature <- (featureQCmetric$filter_celltype &
#'   featureQCmetric$filter_sd &
#'   featureQCmetric$filter_spike)
#' sce <- sce[keep_feature, ]
#'
#' # or manually setting threshold
#' featureQCmetric <- featureQC(sce,
#'   spike = "Ercc",
#'   threshold = 0.25, sd = 0.03, pc = 2
#' )
#' keep_feature <- (featureQCmetric$filter_celltype &
#'   featureQCmetric$sd > 0.02)
#' @importFrom pbapply pbsapply
#' @importFrom scater nexprs
#'
#' @export
featureQC <- function(sce, spike, detection_limit = 1, threshold = 0.25, sd = 0.03, pc = 2) {
  check <- pbsapply(levels(sce$x), function(c) {
    poi <- which(sce$x == c)
    ct_threshold <- nexprs(counts(sce),
      byrow = TRUE, detection_limit = detection_limit,
      subset_col = poi
    ) >=
      length(poi) * threshold
    weighted_mean <- rowSums(assays(sce[, poi])[["ratio_pseudo"]] *
      (counts(sce[, poi]) + 2 * pc) /
      rowSums(counts(sce[, poi]) + 2 * pc))
    return(list(ct_threshold, weighted_mean))
  })
  ct_threshold <- do.call(cbind, check[seq(1, length(check), 2)])
  filter_celltype <- rowSums(ct_threshold) == nlevels(sce$x)

  weighted_mean <- do.call(cbind, check[seq(2, length(check), 2)])
  gsd <- rowSds(weighted_mean)
  filter_sd <- gsd > sd

  filter_spike <- rep(TRUE, nrow(sce))
  if (!missing(spike)) {
    filter_spike[grep(spike, row.names(sce))] <- FALSE
  }

  rowdata <- cbind(rowData(sce), filter_celltype, gsd, filter_sd, filter_spike)
  rowdata
}

#' Fit beta-binomial across cell types
#'
#' This function performs additional inference on the allelic ratio
#' across cell types, giving posterior mean and credible
#' intervals per cell type. A Cauchy prior is centered for
#' each cell type on the allelic ratio from the fused lasso
#' across all genes in the gene cluster
#' (or using a weighted means if the fused lasso is not provided).
#'
#' @param sce A SingleCellExperiment containing assays
#' (\code{"ratio"}, \code{"counts"}) and colData (\code{"x"},
#' \code{"part"})
#' @param formula The same \code{\link[stats]{formula}} object
#' used in \code{\link[airpart]{fusedLasso}} or used in \code{\link[splines]{ns}}
#' when want to detect smooth continuous-axis estimates. eg. formula <- ratio ~ ns(x, df = 5)
#' @param nogroup Indicate whether there is previous group step. Default is FALSE represents either
#' Generalized fused lasso or nonparametric method is used to derive partition. nogroup == TRUE means
#' the hypothesis that groups of cell types sharing a common regulatory context is not valid
#' @param level the level of credible interval (default is 0.95)
#' @param DAItest Indicate whether to do Likelihood Ratio test on differential allelic imbalance(DAI)
#' or equivalent to heterogeneity.
#' @param ... arguments to pass to \code{\link[apeglm]{apeglm}}
#' functions
#'
#' @return posterior mean (\code{"ar"}) for allelic ratio
#' estimate is returned in the rowData for each cell type,
#' as well as the \code{"s"} value, \code{"fsr"} false sign rate and
#' credible interval (\code{"lower"} and \code{"upper"}). One can use \code{"fsr"} < 0.005 or
#' credible intervals contain 0.5 or not for AI test significance. \code{"p.value"} shows DAI test result
#' and \code{"adj.p.value"} is false discovery rate corrected p values.
#'
#' @examples
#'
#' sce <- makeSimulatedData()
#' sce <- preprocess(sce)
#' sce <- geneCluster(sce, G = seq_len(4))
#' sce_sub <- wilcoxExt(sce, genecluster = 1)
#' sce_sub <- allelicRatio(sce_sub, DAItest = TRUE)
#' @importFrom emdbook dbetabinom
#' @importFrom stats as.formula p.adjust pchisq
#' @importFrom splines ns
#'
#' @export
allelicRatio <- function(sce, formula, nogroup = FALSE, level = 0.95, DAItest = FALSE, ...) {
  if (missing(formula)) {
    formula <- ratio ~ p(x, pen = "gflasso")
  }
  add_covs <- grep("p\\(|ns\\(",
                   attr(terms(formula), "term.labels"),
                   invert = TRUE, value = TRUE
  )
  # derive df for continuous variables and return NULL for discrete variable
  if(grepl("ns\\(",attr(terms(formula), "term.labels"))){
    splines = grep("ns\\(",attr(terms(formula), "term.labels"), value = TRUE)
    df = regmatches(splines, regexec('=(.*?)\\)', splines))[[1]][2] %>% as.numeric()
  } else {df = NULL}

  if (isTRUE(nogroup) | !is.null(df)){
    sce$part = sce$x
    metadata(sce)$partition <- data.frame(part = seq_len(nlevels(sce$x)),x = levels(sce$x))
  }

  # derive alternative hypothesis result
  x <- designMatrix(sce, add_covs, df)
  res <- part(sce, x, add_covs, level = level, df = df, ...)

  if(isTRUE(DAItest)){
    npart = nlevels(sce$part)
    # reconstruct coefficient matrix
    coef = res$beta[,!duplicated(res$beta[1,])]
    ratio <- inv.logit(coef %*% t(x) + res$offset)
    loglik1 <- rowSums(emdbook::dbetabinom(assays(sce)[["a1"]], ratio, assays(sce)[["counts"]], res$theta, log=TRUE))
    # derive null hypothesis result
    sce0 <- sce
    sce0$part = factor(1)
    x0 <- designMatrix(sce0, add_covs)
    res0 <- part(sce0, x0, add_covs, level = level, ...)
    coef0 = res0$beta[,!duplicated(res0$beta[1,])]
    ratio0 <- inv.logit(coef0 %*% t(x0) + res0$offset)
    loglik0 <- rowSums(emdbook::dbetabinom(assays(sce0)[["a1"]], ratio0, assays(sce0)[["counts"]], res0$theta, log=TRUE))
    # Construct LR
    LR = -2 * (loglik0-loglik1)
    rowData(sce)$p.value = pchisq(LR, npart-1, lower.tail = FALSE)
    rowData(sce)$adj.p.value = p.adjust(rowData(sce)$p.value, method = "fdr")
  }
  if(is.null(df)){
    mean <- inv.logit(res$beta)
    s <- res$s
    fsr <- res$fsr
    lower <- res$lower
    upper <- res$upper
    est <- data.frame(
      round(mean, 3), format(s, digits = 3), format(fsr, digits = 3),
      round(lower, 3), round(upper, 3)
    ) %>%
      `rownames<-`(rownames(sce))
  }else{
    ## currently only return estimates for continuous case
    ratio <- inv.logit(res$beta %*% t(x))
    mean <- ratio[,!duplicated(ratio[1,])] %>% `colnames<-`(paste("ar", levels(sce$x), sep = "_"))
    est <-data.frame(round(mean, 3))%>% `rownames<-`(rownames(sce))
  }
  est_sub <- est[, setdiff(colnames(est), colnames(rowData(sce)))]
  merged <- merge(rowData(sce), est_sub, by = 0) %>% DataFrame()
  order <- match(rownames(sce), merged$Row.names)
  rowData(sce) <- merged[order, ][-1] %>%
    `rownames<-`(rownames(sce))
  sce
}

## construct design matrix
designMatrix <- function(sce, add_covs, df =NULL){
  if(!is.null(df)){
    X <-list(part = ns(sce$part %>% as.numeric(),df, intercept=TRUE))
  }else{
    if (nlevels(sce$part) == 1) {
      X <- list(part = sce$part)
    } else {
      X <- list(part = model.matrix(~ part + 0, colData(sce)))
    }
  }

  if (length(add_covs) > 0) {
    for (v in add_covs) {
      X[[v]] <- model.matrix(as.formula(paste("~", add_covs, "+0")), colData(sce))
      colnames(X[[v]]) <- levels(sce[[v]])
    }
  }
  X <- do.call(cbind, X)
  return(X)
}


part <-function(sce, x, add_covs, level, df = NULL, ...){
  # rough initial estimate of dispersion
  theta.hat <- matrix(rep(100, dim(sce)[1]))
  maxDisp <- 75
  niter <- 5
  for (i in seq_len(niter)) {
    param <- cbind(theta.hat[, 1], assays(sce)[["counts"]])
    fit.mle <- apeglm(
      Y = assays(sce)[["a1"]], x = x, log.lik = NULL,
      param = param, no.shrink = TRUE, log.link = FALSE,
      method = "betabinCR", interval.level = level,
    )
    theta.hat <- bbEstDisp(
      success = assays(sce)[["a1"]],
      size = assays(sce)[["counts"]], x = x,
      beta = fit.mle$map, minDisp = .01, maxDisp = maxDisp, se = TRUE
    )
  }
  # construct offset if adjusted for batch, and sum them over different batch
  theta <- theta.hat[, 1]
  offset <- matrix(0, ncol = ncol(sce), nrow = nrow(sce))
  if (length(add_covs) > 0) {
    for (v in add_covs) {
      if (nrow(sce) == 1) {
        batch <- fit.mle$map[, match(levels(sce[[v]]), colnames(x))] %>%
          as.matrix() %>%
          t()
      } else {
        batch <- fit.mle$map[, match(levels(sce[[v]]), colnames(x))]
      }
      feat <- sce[[v]]
      offset <- offset + batch[, match(feat, colnames(batch))]
    }
  }
  if (nrow(sce) == 1) {
    param <- cbind(theta, assays(sce)[["counts"]])
    coef <- 0
    res <- adp.shrink(sce, fit.mle, param, level, offset, coef, log.lik = NULL, method = "betabinCR", ...)
  } else {
    se <- theta.hat[, 2]
    ## approximate shrinkage using a formula in the style of
    # Efron and Morris's hierarchical model of normals
    log_disp <- log(theta)
    sigma_sampling2 <- mean(se^2)
    sigma_prior2 <- max((var(log_disp) - sigma_sampling2), 0)
    B <- as.numeric((sigma_sampling2) / (sigma_prior2 + sigma_sampling2))
    log_disp_0 <- mean(log_disp)
    theta2 <- exp((1 - B) * log_disp + B * log_disp_0)
    param <- cbind(theta2, assays(sce)[["counts"]])
    ## estimating prior mean
    if ("coef" %in% colnames(colData(sce))) {
      ## use fused lasso estimates as prior
      coef <- unique(data.frame(x = sce$part, coef = sce$coef))$coef
    } else {
      ## use weighted mean as prior
      cl_ratio <- as.vector(unlist(assays(sce)[["ratio"]]))
      cl_total <- as.vector(unlist(assays(sce)[["counts"]]))
      dat <- data.frame(
        ratio = cl_ratio,
        part = factor(rep(sce$part, each = length(sce))),
        cts = cl_total
      )
      summary <- dat %>%
        group_by(.data$part) %>%
        summarise(coef = weighted.mean(.data$ratio,
                                       .data$cts,
                                       na.rm = TRUE
        )) %>%
        as.data.frame()
      coef <- merge(summary, unique(data.frame(part = sce$part, x = sce$x)),
                    by = "part", sort = FALSE
      )$coef
      coef <- log(coef / (1 - coef))
    }
    if(!is.null(df)){
      res <- adp.shrink(sce, fit.mle, param, level, offset, coef, log.lik = betabinom.log.lik, method = "general", df =df, ...)
    }else{
      ## Shrink one cell type/time
      res <- adp.shrink(sce, fit.mle, param, level, offset, coef, log.lik = betabinom.log.lik, method = "general", ...)
    }
  }
  return(res)
}

## Betabinomial log link
betabinom.log.lik <- function(y, x, beta, param, offset) {
  xbeta <- x %*% beta + offset
  p.hat <- (1 + exp(-xbeta))^-1
  emdbook::dbetabinom(y,
                      prob = p.hat, size = param[-1],
                      theta = param[1], log = TRUE
  )
}

## derive adaptive shrinkage with prior
adp.shrink <- function(sce, fit.mle, param, level, offset, coef, log.lik, method, df=NULL, ...) {
  npart <- nlevels(sce$part)
  nct <- nlevels(sce$x)
  ##
  group <- unique(data.frame(x = sce$x, part = sce$part))
  ## store results
  beta <- matrix(0, nrow = length(sce), ncol = nct) %>%
    `colnames<-`(paste("ar", group$x, sep = "_"))
  s <- matrix(0, nrow = length(sce), ncol = nct) %>%
    `colnames<-`(paste("svalue", group$x, sep = "_"))
  fsr <- matrix(0, nrow = length(sce), ncol = nct) %>%
    `colnames<-`(paste("fsr", group$x, sep = "_"))
  lower <- matrix(0, nrow = length(sce), ncol = nct) %>%
    `colnames<-`(paste("lower", paste0((1 - level) * 50, "pct"),
                       group$x,
                       sep = "_"
    ))
  upper <- matrix(0, nrow = length(sce), ncol = nct) %>%
    `colnames<-`(paste("upper", paste0(100 - (1 - level) * 50, "pct"),
                       group$x,
                       sep = "_"
    ))
  if(!is.null(df)){
    x <- designMatrix(sce, add_covs = NULL, df)
    fit2 <- apeglm(
      Y = assays(sce)[["a1"]], x = x, log.lik = NULL,
      param = param, no.shrink = TRUE, offset = offset, log.link = FALSE,
      method = "betabinCR", interval.level = level,
    )
    beta = fit2$map
    return(list(beta = beta, offset = offset, theta = param[,1]))
  }else{
    part <- group$part
    if (nlevels(sce$part) == 1) {
      x <- data.frame(part = as.numeric(sce$part)) %>% as.matrix()
    } else {
      x <- model.matrix(~ part + 0, colData(sce))
    }
    for (j in seq_len(npart)) {
      fit.post <- apeglm(
        Y = assays(sce)[["a1"]], x = x, param = param, log.lik = log.lik,
        coef = j, interval.level = level, offset = offset,
        log.link = FALSE, method = method,
        prior.control = list(
          no.shrink = setdiff(seq_len(ncol(x)), j), prior.mean = coef,
          prior.scale = 1, prior.df = 1,
          prior.no.shrink.mean = 0, prior.no.shrink.scale = 15
        ), ...
      )
      beta[, which(part == levels(part)[j])] <- fit.post$map[, j]
      s[, which(part == levels(part)[j])] <- fit.post$svalue
      fsr[, which(part == levels(part)[j])] <- fit.post$fsr
      lower[, which(part == levels(part)[j])] <- inv.logit(fit.post$interval[, 1])
      upper[, which(part == levels(part)[j])] <- inv.logit(fit.post$interval[, 2])
    }
    return(list(beta = beta, s = s, fsr = fsr, lower = lower, upper = upper, offset = offset, theta = param[,1]))
  }
}

inv.logit <- function(x) (1 + exp(-x))^-1

#' Allelic ratio summary
#'
#' Oroduce allelic ratio summaries for each gene cluster
#'
#' @param sce SingleCellExperiment
#' @param genecluster an optional vector of gene cluster IDs.
#' if nothing is given, all cluster's summaries will be
#' calculated
#'
#' @return a list of gene cluster summary tables containing:
#' \itemize{
#'   \item{weighted.mean} {weighted mean of allelic ratio for the cell types}
#'   \item{mean} {mean allelic ratio for the cell types}
#'   \item{var} {variance of allelic ratio for the cell types}
#' }
#'
#' @examples
#'
#' library(S4Vectors)
#' sce <- makeSimulatedData()
#' sce <- preprocess(sce)
#' sce <- geneCluster(sce, G = 1:4)
#' summary <- summaryAllelicRatio(sce, genecluster = c(1, 3))
#' summary
#' @importFrom dplyr summarise group_by %>%
#' @importFrom stats var weighted.mean
#'
#' @export
summaryAllelicRatio <- function(sce, genecluster) {
  if (missing(genecluster)) {
    genecluster <- seq_len(max(rowData(sce)$cluster))
  }
  res <- lapply(genecluster, function(i) {
    sce_sub <- sce[rowData(sce)$cluster == i, ]
    cl_ratio <- as.vector(unlist(assays(sce_sub)[["ratio"]]))
    cl_total <- as.vector(unlist(assays(sce_sub)[["counts"]]))
    dat <- data.frame(
      ratio = cl_ratio,
      x = factor(rep(sce_sub$x, each = length(sce_sub))),
      cts = cl_total
    )
    summary <- dat %>%
      group_by(.data$x) %>%
      summarise(
        weighted.mean = weighted.mean(.data$ratio, .data$cts,
          na.rm = TRUE
        ),
        mean = mean(.data$ratio, na.rm = TRUE),
        var = var(.data$ratio, na.rm = TRUE)
      ) %>%
      as.data.frame()
    summary
  })
  names(res) <- paste(
    "gene cluster", genecluster, "with",
    metadata(sce)$geneCluster[genecluster], "genes"
  )
  return(res)
}

#' Extension on Pairwise Mann Whitney Wilcoxon Test for partitioning
#'
#' Extends the Pairwise Mann Whitney Wilcoxon Test by combining
#' hierarchical clustering for partition.
#'
#' @param sce A SingleCellExperiment containing assays (\code{"ratio"},
#' \code{"counts"}) and colData \code{"x"}
#' @param genecluster which gene cluster result want to be returned.
#' Usually identified interesting gene cluster pattern by
#' \code{\link{summaryAllelicRatio}}
#' @param threshold a vector with candidate thresholds for raw p-value
#' cut-off. Default is 10^seq(from=-2,to=-0.4,by=0.2).
#' For details please see vignette
#' @param adj.matrix an adjacency matrix with 1 indicates cell states
#' allowed to be grouped together, 0 otherwise.
#' @param p.adjust.method method for adjusting p-values
#' (see \code{\link[stats]{p.adjust}}). Can be abbreviated
#' @param ncores A cluster object created by \code{\link[parallel]{makeCluster}}.
#' Or an integer to indicate number of child-processes
#' (integer values are ignored on Windows) for parallel evaluations
#' @param ... additional arguments to pass to \code{\link[stats]{wilcox.test}}.
#'
#' @return A matrix grouping factor partition and
#' the significant cut-off threshold
#' are returned in metadata \code{"partition"} and \code{"threshold"}.
#' Partation also stored in colData\code{"part"}. Note we recommend the returned 
#' \code{"threshold"} is not at the ends of input \code{"threshold"}.
#'
#' @examples
#' library(S4Vectors)
#' sce <- makeSimulatedData()
#' sce <- preprocess(sce)
#' sce <- geneCluster(sce, G = seq_len(4))
#' sce_sub <- wilcoxExt(sce, genecluster = 1)
#' metadata(sce_sub)$partition
#' metadata(sce_sub)$threshold
#'
#' # Suppose we have 4 cell states, if we don't want cell state 1
#' # to be grouped together with other cell states
#' adj.matrix <- 1 - diag(4)
#' colnames(adj.matrix) <- rownames(adj.matrix) <- levels(sce$x)
#' adj.matrix[1, c(2, 3, 4)] <- 0
#' adj.matrix[c(2, 3, 4), 1] <- 0
#' thrs <- 10^seq(from = -2, to = -0.4, by = 0.1)
#' sce_sub <- wilcoxExt(sce,
#'   genecluster = 1, threshold = thrs,
#'   adj.matrix = adj.matrix
#' )
#' metadata(sce_sub)$partition
#' @importFrom dplyr left_join
#' @importFrom plyr mutate
#' @importFrom stats pairwise.wilcox.test
#' @importFrom pbapply pblapply
#'
#' @export
wilcoxExt <- function(sce, genecluster, threshold, adj.matrix,
                      p.adjust.method = "none", ncores = NULL, ...) {
  if (missing(threshold)) {
    threshold <- 10^seq(from = -2, to = -0.4, by = 0.2)
  }
  if (missing(genecluster)) {
    stop("No gene cluster number")
  }
  nct <- nlevels(sce$x)
  if (missing(adj.matrix)) {
    adj.matrix <- matrix(1, nct, nct)
  }
  stopifnot(c("ratio", "counts") %in% assayNames(sce))
  stopifnot("x" %in% names(colData(sce)))
  stopifnot("cluster" %in% names(rowData(sce)))

  ## construct data frame
  sce_sub <- sce[rowData(sce)$cluster == genecluster, ]
  cl_ratio <- as.vector(unlist(assays(sce_sub)[["ratio"]]))
  cl_total <- as.vector(unlist(counts(sce_sub)))
  dat <- data.frame(
    ratio = cl_ratio,
    x = factor(rep(sce_sub$x, each = length(sce_sub))),
    cts = cl_total
  )

  obj <- pblapply(threshold, select_thrs,
    dat = dat, p.adjust.method = p.adjust.method,
    adj.matrix = adj.matrix, cl = ncores, ...
  )

  cl <- do.call(rbind, lapply(obj, `[[`, 1))
  loss1 <- do.call(rbind, lapply(obj, `[[`, 2))
  partition <- data.frame(
    part = factor(cl[which.min(loss1), ]),
    x = levels(sce_sub$x)
  )
  colData(sce_sub)$part <- partition$part[match(colData(sce_sub)$x, partition$x)]
  metadata(sce_sub)$partition <- partition
  metadata(sce_sub)$threshold <- threshold[which.min(loss1)]
  return(sce_sub)
}

## not exported
select_thrs <- function(threshold, dat, p.adjust.method, adj.matrix, ...) {
  fit <- wilcoxInt(dat,
    p.adjust.method = p.adjust.method,
    threshold = threshold, adj.matrix = adj.matrix, ...
  )
  label <- data.frame(type = factor(levels(dat$x)), par = factor(fit))
  dat2 <- dat %>%
    left_join(label, by = c("x" = "type"))
  dat2 <- dat2 %>%
    group_by(.data$par) %>%
    dplyr::mutate(grpmean = mean(.data$ratio, na.rm = TRUE))
  ## loss function
  loss1 <- nrow(dat) * log(sum((dat2$ratio - dat2$grpmean)^2, na.rm = TRUE) /
    nrow(dat2)) + length(unique(fit)) * log(nrow(dat2))
  return(list(cl = fit, loss1 = loss1))
}

## not exported
wilcoxInt <- function(data, threshold = 0.05,
                      p.adjust.method = "none", adj.matrix, ...) {
  nct <- length(levels(data$x))
  res <- pairwise.wilcox.test(data$ratio, data$x,
    p.adjust.method = p.adjust.method, ...
  )
  adj <- as.data.frame(res$p.value)[lower.tri(res$p.value, diag = TRUE)]
  ## Wilcoxon output Nan if ratio of two cell types are exactly same
  adj <- ifelse(is.nan(adj), 1, adj)
  b <- matrix(0, nct, nct)
  b[lower.tri(b, diag = FALSE)] <- adj
  b2 <- b + t(b)
  diag(b2) <- 1
  b2[which(adj.matrix == 0)] <- 0
  ## binarize p-value to be seen as dismilarity matrix
  bb <- ifelse(b2 < threshold, 1, 0)
  ## hierarchical cluster on adjacency matrix
  clust <- hclust(as.dist(bb))
  my.clusters <- cutree(clust, h = 0)
  return(my.clusters)
}

#' Consensus Partitions
#'
#' Derive consensus partitions of an ensemble fused lasso partitions.
#'
#' @param sce SingleCellExperiment
#'
#' @return A matrix grouping factor partition is replaced in metadata.
#' Consensus Partation also stored in colData\code{"part"}.
#'
#' @examples
#' library(smurf)
#' sce <- makeSimulatedData()
#' sce <- preprocess(sce)
#' sce <- geneCluster(sce, G = 1:4)
#' f <- ratio ~ p(x, pen = "gflasso") # formula for the GFL
#' sce_sub <- fusedLasso(sce,
#'   formula = f, model = "binomial", genecluster = 1,
#'   niter = 2, ncores = 2, se.rule.nct = 3
#' )
#' sce_sub <- consensusPart(sce_sub)
#' @importFrom clue cl_consensus cl_ensemble as.cl_hard_partition
#' @importFrom dplyr select
#' @import lpSolve
#'
#' @export
consensusPart <- function(sce) {
  cl <- data.frame(metadata(sce)$partition) %>% select(-.data$x)
  consens_part <- cl_consensus(
    cl_ensemble(list = apply(cl, 2, as.cl_hard_partition)),
    method = "SM"
  )
  class <- max.col(consens_part$.Data)
  class <- match(class, unique(class))
  cl <- data.frame(part = factor(class), x = levels(sce$x))
  colData(sce) <- merge(colData(sce), cl) %>%
    DataFrame() %>%
    `row.names<-`(colnames(sce))
  metadata(sce)$partition <- cl
  return(sce)
}

#' Plot group partition and posterior allelic ratio estimates by step
#'
#' @param sce SingleCellExperiment
#' @param xlab the x axis name.
#'
#' @return a ggplot2 object.
#'
#' @examples
#'
#' sce <- makeSimulatedData()
#' sce <- preprocess(sce)
#' sce <- geneCluster(sce, G = 1:4)
#' sce_sub <- wilcoxExt(sce, genecluster = 1)
#' sce_sub <- allelicRatio(sce_sub)
#' makeStep(sce_sub)
#' @export
makeStep <- function(sce, xlab = "cell type") {
  ar <- rowData(sce)[, c(grep("ar_", colnames(rowData(sce)), value = TRUE))] %>%
    `colnames<-`(levels(sce$x))
  dat <- data.frame(
    ratio = as.vector(unlist(ar)),
    x = factor(rep(unique(sce$x), each = length(sce))),
    part = factor(rep(metadata(sce)$partition$part, each = length(sce))),
    feat = factor(rep(row.names(sce), nlevels(sce$x)), levels = row.names(sce))
  )
  p <- ggplot2::ggplot(dat, aes(x = .data$x, y = .data$ratio)) +
    ggplot2::geom_point(aes(color = .data$part)) +
    ggplot2::geom_step(group = 1) +
    ggplot2::geom_hline(yintercept = 0.5, colour = "gray40", linetype = "dashed") +
    ggplot2::facet_wrap(~feat) +
    theme_minimal() +
    theme(
      legend.position = "bottom",
      panel.grid.minor = element_blank(),
      panel.border = element_rect(fill = "transparent")
    ) +
    labs(x = xlab, y = "allelic ratio")
  p
}

#' Posterior mean allelic ratio estimates in violin plots
#'
#' @param sce SingleCellExperiment
#' @param xlab the x axis name.
#' @param ylim the y axis range
#'
#' @return a ggplot2 object, \code{n} represents number of cells in that cell type.
#'
#' @examples
#'
#' sce <- makeSimulatedData()
#' sce <- preprocess(sce)
#' sce <- geneCluster(sce, G = 1:4)
#' sce_sub <- wilcoxExt(sce, genecluster = 1)
#' sce_sub <- allelicRatio(sce_sub)
#' makeViolin(sce_sub)
#' @export
makeViolin <- function(sce, xlab = "cell type", ylim = c(0,1)) {
  ylim1<- ylim[1]
  ylim2<- ylim[2]
  ar <- rowData(sce)[, c(grep("ar_", colnames(rowData(sce)), value = TRUE))] %>%
    `colnames<-`(levels(sce$x))
  dat <- data.frame(
    ratio = as.vector(unlist(ar)),
    x = factor(rep(levels(sce$x), each = length(sce))),
    part = factor(rep(metadata(sce)$partition$part, each = length(sce)))
  )
  sample_size <- data.frame(table(sce$x)) %>% `colnames<-`(c("x", "n"))
  dat <- dat %>%
    left_join(sample_size)
  dat$myaxis <- paste0(dat$x, "\n", "n=", dat$n) %>% as.factor()
  dat$myaxis <- factor(dat$myaxis, levels = unique(paste0(dat$x, "\n", "n=", dat$n)))
  p <- ggplot(dat, aes(x = .data$myaxis, y = .data$ratio, fill = .data$part)) +
    geom_violin(color = "#A4A4A4", size = 1.2, alpha = .7) +
    geom_boxplot(width = 0.1, color = "black") +
    theme_minimal() + ylim(ylim1,ylim2) + 
    theme(
      legend.position = "bottom",
      panel.grid.minor = element_blank(),
      panel.border = element_rect(fill = "transparent")
    ) +
    scale_fill_brewer(palette = "Set2") +
    labs(x = xlab, y = "allelic ratio")
  p
}

#' Extract results from an airpart analysis
#'
#' results extracts a result table from an airpart analysis giving posterior allelic ratio estimates,
#' s values, false sign rate(fsr), upper confidence interval and lower confidence interval.
#'
#' @param sce SingleCellExperiment
#' @param estimates the estimates want to be extracted. Default is allelic ratio estimates,
#' can be \code{"svalue"}, \code{"fsr"}, \code{"lower"}(credible interval) and \code{"upper"}(credible interval)
#'
#' @return a DataFrame of estimates
#'
#' @examples
#'
#' sce <- makeSimulatedData()
#' sce <- preprocess(sce)
#' sce <- geneCluster(sce, G = 1:4)
#' sce_sub <- wilcoxExt(sce, genecluster = 1)
#' sce_sub <- allelicRatio(sce_sub)
#' ar <- extractResult(sce_sub)
#' ar
#' @export
extractResult <- function(sce, estimates = c("ar", "svalue", "fsr", "lower", "upper")) {
  estimates <- match.arg(estimates, c("ar", "svalue", "fsr", "lower", "upper"))
  estimates <- paste0(estimates,"_")
  group <- unique(data.frame(x = sce$x, part = sce$part))
  res <- rowData(sce)[, c(grep(estimates, colnames(rowData(sce)), value = TRUE))] %>%
    `colnames<-`(group$x %>% as.character())
  order <- match(levels(sce$x),colnames(res))
  res <- res[,order]
  if(estimates %in% c("svalue_","fsr_")){
    if(nrow(sce)==1){
      res <- sapply(res, as.numeric) %>% as.matrix() %>% t() %>% `rownames<-`(rownames(sce))
    }else{
      res <- DataFrame(sapply(res, as.numeric) %>% `rownames<-`(rownames(sce)))
    }
  }
  res
}

#' Estimate overdispersion parameter of a beta-binomial
#'
#' @param sce SingleCellExperiment with \code{a1} matrix and \code{counts}
#' @param genecluster the gene cluster for which to estimate the
#' over-dispersion parameter. Default is the cluster with the most cells
#' @param type whether to output the over-dispersion estimates as a plot or a value
#'
#' @return A ggplot object of the dispersion estimates over the mean,
#' or a data.frame of the mean and dispersion estimates (theta)
#'
#' @examples
#'
#' sce <- makeSimulatedData()
#' sce <- preprocess(sce)
#' sce <- geneCluster(sce, G = seq_len(4))
#' estDisp(sce, genecluster = 1)
#' @importFrom apeglm apeglm bbEstDisp
#' @importFrom stats model.matrix
#'
#' @export
estDisp <- function(sce, genecluster, type = c("plot", "values")) {
  type <- match.arg(type, c("plot", "values"))
  stopifnot("cluster" %in% names(rowData(sce)))
  if (missing(genecluster)) {
    cl <- metadata(sce)$geneCluster
    genecluster <- names(cl[which.max(cl)])
  }
  sce_sub <- sce[rowData(sce)$cluster == genecluster, ]
  x <- model.matrix(~x, colData(sce))
  theta.hat <- 100
  param <- cbind(theta.hat, counts(sce_sub))
  maxDisp <- 5000
  for (i in seq_len(5)) {
    param <- cbind(theta.hat, counts(sce_sub))
    fit.mle <- apeglm(
      Y = assays(sce_sub)[["a1"]], x = x, log.lik = NULL,
      param = param, no.shrink = TRUE, log.link = FALSE, method = "betabinC"
    )
    theta.hat <- bbEstDisp(
      success = assays(sce_sub)[["a1"]],
      size = counts(sce_sub), x = x,
      beta = fit.mle$map, minDisp = .01, maxDisp = maxDisp
    )
  }
  gene_mean <- rowMeans(counts(sce_sub))
  est <- data.frame(mean = gene_mean, theta = theta.hat)
  ## focus on genes with evidence of over-dispersion
  est <- est[est$mean > 2 & est$theta < 100, ]
  if (type == "plot") {
    p <- ggplot(est, aes(mean, .data$theta)) +
      geom_point() +
      geom_smooth() +
      coord_cartesian(ylim = c(0, 100)) +
      theme_minimal() +
      labs(x = "gene mean", y = "theta")
    p
  } else {
    est
  }
}

#' Plot allelic ratio result as forest
#'
#' Draw a forest plot to visualized cell type specific
#' allelic ratio estimator and confidence interval.
#' It is based on the \pkg{forestplot}-package`s \code{forestplot} function.
#'
#' @param sce A SingleCellExperiment containing colData
#' allelic ratio estimator in the third column
#' and last two column is the confidence interval.
#' @param genepoi the gene position index or gene name vector that want to be plotted.
#' Ordered by increased cell type svalue.
#' Default is the top 40 genes that has minimum svalue in any cell type
#' or all genes if number of genes smaller than 40.
#' @param ctpoi the cell type position index that want to be plotted.
#' @param showtext indicate whether show the svalue information along the forestplot.
#' @param xticks argument as described in \code{\link[forestplot]{forestplot}}
#' @param boxsize Override the default box size based on precision
#' @param xlab x-axis label. Default is "Allelic Ratio"
#' @param col Set the colors for all the elements. See
#' \code{\link[forestplot]{fpColors}} for details
#' @param grid If you want a discrete gray dashed grid
#' at the level of the ticks
#' you can set this parameter to TRUE.
#' If you set the parameter to a vector of values lines will be drawn at the
#' corresponding positions.
#' If you want to specify the \code{\link[grid]{gpar}} of the lines
#' then either directly pass a \code{\link[grid]{gpar}} object
#' or set the gp attribute e.g.
#' \code{attr(line_vector, "gp") <- }
#' \code{\link[grid]{gpar}}\code{(lty=2, col = "red")}
#' @param ... Passsed on the other argument in
#' \code{\link[forestplot]{forestplot}}.
#'
#' @return generates a forest plot
#'
#' @seealso \code{\link[forestplot]{forestplot}},
#' \code{\link[forestplot]{fpColors}},
#' \code{\link[forestplot]{fpShapesGp}}, \code{\link[forestplot]{fpLegend}}
#'
#' @examples
#' sce <- makeSimulatedData()
#' sce <- preprocess(sce)
#' sce <- geneCluster(sce, G = 1:4)
#' sce_sub <- wilcoxExt(sce, genecluster = 1)
#' sce_sub <- allelicRatio(sce_sub)
#' makeForest(sce_sub, showtext = TRUE)
#'
#' # if want to change some properties, like ticks position
#' library(forestplot)
#' xticks <- seq(from = 0, to = 1, by = 0.25)
#' xtlab <- rep(c(TRUE, FALSE), length.out = length(xticks))
#' attr(xticks, "labels") <- xtlab
#' genepoi <- paste0("gene", seq_len(5))
#' ctpoi <- c(1, 3)
#' makeForest(sce_sub, genepoi, ctpoi,
#'   xticks = xticks,
#'   col = fpColors(box = c("blue", "red", "black", "darkgreen"))
#' )
#' @import grid
#' @import forestplot
#' @importFrom utils head
#'
#' @export
makeForest <- function(sce, genepoi, ctpoi = seq_len(nlevels(sce$x)), showtext = FALSE, xticks, boxsize = .25,
                       xlab = "Allelic Ratio", col,
                       grid = structure(seq(0.1, 0.9, 0.1),
                         gp = gpar(lty = 2, col = "#CCCCFF")
                       ), ...) {
    qual_col_pals <- brewer.pal.info[brewer.pal.info$category == "qual", ]
    col_vector <- unlist(mapply(brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  if (missing(xticks)) {
    xticks <- seq(from = 0, to = 1, by = 0.1)
    xtlab <- rep(c(TRUE, FALSE, TRUE, FALSE, FALSE), length.out = length(xticks))
    attr(xticks, "labels") <- xtlab
  }
  if (missing(col)) {
    col <- fpColors(box = col_vector[seq_len(length(ctpoi))])
  }
  ar <- rowData(sce)[, c(grep("svalue", colnames(rowData(sce)), value = TRUE))] %>% `colnames<-`(levels(sce$x))
  if (showtext) {
    forest_text <- data.frame(`Gene` = rownames(sce), ar[, ctpoi])
  } else {
    forest_text <- data.frame(Gene = rownames(sce)) %>% `rownames<-`(rownames(ar))
  }
  if (missing(genepoi)) {
    smin <- apply(apply(ar, 2, as.numeric), 1, min)
    genepoi <- head(order(smin), min(40, nrow(sce)))
  }
  forest_text <- rbind(colnames(forest_text), forest_text[genepoi, ] %>% as.data.frame())
  message("svalue shown in columns per cell type")
  forestplot::forestplot(forest_text,
    is.summary = c(TRUE, rep(FALSE, nrow(forest_text) - 1)),
    hrzl_lines = list("2" = gpar(lty = 2)),
    line.margin = .1, # We need to add this to avoid crowding
    legend = levels(sce$x)[ctpoi], grid = grid,
    txt_gp = fpTxtGp(
      label = list(gpar(cex = 0.8), gpar(cex = 0.8, col = "#703C3C")),
      ticks = gpar(cex = 0.9), xlab = gpar(cex = 0.9)
    ),
    boxsize = boxsize, graphwidth = unit(15, "cm"),
    mean = rbind(rep(NA, length(ctpoi)), rowData(sce)[genepoi, c(grep("ar_", colnames(rowData(sce)), value = TRUE))[ctpoi]] %>% as.matrix()),
    lower = rbind(rep(NA, length(ctpoi)), rowData(sce)[genepoi, c(grep("lower_", colnames(rowData(sce)), value = TRUE))[ctpoi]] %>% as.matrix()),
    upper = rbind(rep(NA, length(ctpoi)), rowData(sce)[genepoi, c(grep("upper_", colnames(rowData(sce)), value = TRUE))[ctpoi]] %>% as.matrix()),
    clip = c(0.01, 1), xticks = xticks, ref = 0.5,
    col = col, xlab = xlab
  )
}

#' Make simulated data for airpart
#'
#' @param ngenecl number of genes per gene cluster
#' @param mu1 low count (typical of "noisy" ratio estimates)
#' @param mu2 high count
#' @param nct number of cell types
#' @param n number of cells per cell type
#' @param ngenecl number of genes per cluster
#' @param theta overdispersion parameter (higher is closer to binomial)
#' @param ncl number of gene cluster
#' @param p.vec the allelic ratio vector which follows gene cluster order.
#' (length is nct * ncl)
#' @param totalClusters logical, whether cell types should cluster by total
#' count
#'
#' @return SingleCellExperiment with the following elements as assays
#' \itemize{
#'   \item{a1} {allelic count matrix for the numerator/effect allele}
#'   \item{a2} {allelic count matrix for the denominator/non-effect allele}
#'   \item{true.ratio} {a matrix of the true probabilities
#' (allelic ratios) for the cell types}
#' }
#' Also \code{x} in the colData is a vector of annotated
#' cell types in the same order as cells in count matrix
#'
#' @examples
#' library(SummarizedExperiment)
#' sce <- makeSimulatedData()
#' assayNames(sce)
#' @importFrom emdbook rbetabinom
#' @importFrom SingleCellExperiment SingleCellExperiment
#' @importFrom stats rnbinom
#'
#' @export
makeSimulatedData <- function(mu1 = 2, mu2 = 10, nct = 4, n = 30,
                              ngenecl = 50, theta = 20, ncl = 3,
                              p.vec = rep(c(0.2, 0.8, 0.5, 0.5, 0.7, 0.9),
                                          each = 2),
                              totalClusters=FALSE
                              ) {
  if ((length(p.vec) / ncl) != nct) {
    stop("allelic ratio number is not matched with the product of
  number of cell types and number of gene cluster")
  }

  ngene <- ncl * ngenecl # total number of genes
  nclcell <- nct * n * ngenecl # number elements within each gene cluster
  
  if (!totalClusters) {
    ## mean total count
    mean_total_count <- rep(rep(c(mu1, mu2), each = n / 2), times = nct * ngene)
    ## total count matrix
  } else {
    ## cell types cluster by total count
    mean_total_count = as.vector(replicate(ngene, {
      rep(sample(c(mu1,mu2),size=nct,TRUE), each=n)
    }))
  }
  cts <- matrix(rnbinom(n * nct * ngene, mu = mean_total_count, size = 5),
                nrow = ngene, byrow = TRUE)
  p <- rep(p.vec, each = n * nct * ngene / length(p.vec))

  ## allelic expression matrix for the effect allele
  a1 <- lapply(seq_len(ncl), function(m) {
    matrix(emdbook::rbetabinom(nclcell,
      prob = p[(nclcell * m - nclcell + 1):(nclcell * m)],
      size = cts[(m * ngenecl - ngenecl + 1):(m * ngenecl), ],
      theta = theta
    ), ncol = nct * n)
  })
  a1 <- do.call(rbind, a1)
  colnames(a1) <- paste0("cell", seq_len(nct * n))
  rownames(a1) <- paste0("gene", seq_len(ngene))
  a2 <- cts - a1
  x <- factor(rep(paste0("ct", seq_len(nct)), each = n)) # cell type vector

  true.ratio <- matrix(vapply(seq_len(ncl), function(m) {
    rep(p.vec[((m - 1) * nct + 1):(m * nct)], ngenecl)
  }, double(nct * ngenecl)),
  ncol = nct, byrow = TRUE
  )

  colnames(true.ratio) <- paste0("ct", seq_len(nct)) # cell type names
  coldata <- data.frame(x = factor(x, levels = unique(x)))
  rowdata <- data.frame(true.ratio)
  assay.list <- list(a1 = a1, a2 = a2)
  SingleCellExperiment(
    assays = assay.list,
    colData = coldata, rowData = rowdata
  )
}

#' Preprocess the SingleCellExperiment
#'
#' @param sce SingleCellExperiment with \code{a1} (effect allele)
#' and \code{a2} (non-effect allele). The allelic ratio will be
#' calculated as a1 / (a1 + a2).
#' @param pc pseudocount for calculating the smoothed ratio
#'
#' @return SingleCellExperiment with total count,
#' allelic ratio = a1/(a1 + a2), and pseud-ocount-smoothed ratio
#'
#' @examples
#' library(SummarizedExperiment)
#' sce <- makeSimulatedData()
#' sce <- preprocess(sce)
#' assayNames(sce)
#' @importFrom utils packageVersion
#'
#' @export
preprocess <- function(sce, pc = 2) {
  if (any(assays(sce)[["a1"]] != round(assays(sce)[["a1"]]))) {
    warning("Functions estDisp, fusedLasso expect integers")
  }
  assays(sce)[["counts"]] <- assays(sce)[["a1"]] +
    assays(sce)[["a2"]]
  assays(sce)[["ratio"]] <- assays(sce)[["a1"]] /
    assays(sce)[["counts"]]
  assays(sce)[["ratio_pseudo"]] <- (assays(sce)[["a1"]] + pc) /
    (assays(sce)[["counts"]] + 2 * pc)
  metadata(sce) <- list(airpartVersion = packageVersion("airpart"))
  sce
}

---
title: "Differential cell-type-specific allelic imbalance with airpart"
author: 
  - name: "Wancen Mu, Hirak Sarkar, Avi Srivastava, Kwangbom Choi, Rob Patro, Michael I. Love"
date: "`r format(Sys.Date(), '%m/%d/%Y')`"
abstract: |
  Airpart identifies sets of genes displaying differential
  cell-type-specific allelic imbalance across cell types
  or states, utilizing single-cell allelic counts. It makes use of a
  generalized fused lasso with binomial observations of allelic
  counts to partition cell types by their allelic
  imbalance. Alternatively, a nonparametric method for partitioning
  cell types is offered. The package includes a number of
  visualizations and quality control functions for examining single
  cell allelic imbalance datasets.
output: 
  html_document:
    toc: true
    toc_float: true 
    theme: united
    highlight: tango
vignette: |
  %\VignetteIndexEntry{Differential allelic imbalance with airpart}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

# Real data example

Vignette on Larsson 2019 data can be found 
[here](https://htmlpreview.github.io/?https://github.com/Wancen/airpartpaper/blob/main/Larsson2019/Larsson2019.html),
which has allelic single-cell RNA-seq with 4 cell states.

# Simulated data example I

The *airpart* package takes input data of counts from each of two
alleles across genes (rows) and cells (columns) from a single-cell
RNA-seq experiment.

For demonstration in the package vignette, we will simulate some data
using `makeSimulatedData` function provided within the *airpart*
package. We will examine the allelic counts and then perform QC steps
before analyzing the data for allelic imbalance across groups of cells.

## Simulation set-up

The simulated example dataset has 3 gene clusters with differential
allelic imbalance (DAI): 

* the first cluster has pairs of cell types with same allelic ratio
  with 0.2 and 0.8 (larger DAI) 
* the second cluster has balanced allelic ratio
* the third cluster has pairs of cell types with same allelic ratio
  with 0.7 and 0.9 (smaller DAI)

Below we specify a number of simulation settings as arguments to the
simulation function:

* the "noisy" cell count is 2
* the normal cell count is 10
* 4 cell types
* 20 cells within each cell type
* 25 genes within each gene cluster
* overdispersion parameter `theta` in `rbetabinom` is 20 (higher is
  less dispersion)

```{r}
library(airpart)
suppressPackageStartupMessages(library(SingleCellExperiment))
p.vec <- rep(c(0.2, 0.8, 0.5, 0.5, 0.7, 0.9), each = 2)
set.seed(2021)
sce <- makeSimulatedData(
  mu1 = 2, mu2 = 10, nct = 4, n = 20,
  ngenecl = 25, theta = 20, ncl = 3,
  p.vec = p.vec
)
```

```{r}
unique(rowData(sce)) # the true underlying allelic ratios
table(sce$x) # counts of each cell type
assays(sce)[["a1"]][1:5, 1:5] # allelic counts for the effect allele
```

## Required input data

In summary, *airpart* expects a *SingleCellExperiment* object with:

* discrete cell types recorded as a variable `x` in the `colData(sce)`
* effect and non-effect allelic counts as assays `a1` and `a2`

The allelic ratio is calculated as `a1 / (a1 + a2)`.

Note: We assume that the cell types have been either provided by the
experiment, or identified based on total count. We assume the allelic
ratio was not used in determining the cell groupings in `x`.

```{r}
assayNames(sce)
sce$x
```

# Create allelic ratio matrix

In the `preprocess` step, we add a pseudo-count for gene clustering
and visualization (not used for inference later on allelic imbalance
though, which uses original allelic counts). From the heatmap, we can
clearly identify the three gene clusters (across rows), and we also
see cell type differences (across columns). Within each cell type,
there are some cells with noisier estimates (lower total count) than
others. Again, the allelic ratio tells us how much more of the `a1`
allele is expressed, with 1 indicating all of the expression coming
from the `a1` allele and 0 indicating all of the expression coming
from the `a2` allele.

```{r}
sce <- preprocess(sce)
makeHeatmap(sce)
```

# Quality control steps

## QC on cells

We recommend both QC on cells and on genes. We begin with cell allelic
ratio quality control. For details on these metrics, see `?cellQC`.

```{r}
cellQCmetrics <- cellQC(sce, mad_detected = 4)
cellQCmetrics
```

Now define cell filtering automatically or users can manually filter
out based on `sum`,`detected` and `spikePercent`.

```{r}
keep_cell <- (
  cellQCmetrics$filter_sum | # sufficient features (genes)
    cellQCmetrics$filter_detected | # sufficient molecules counted
    # sufficient features expressed compared to spike genes,
    # high quality cells
    cellQCmetrics$filter_spike
)
sce <- sce[, keep_cell]
```

## QC on genes

We also recommend QC on genes for allelic ratio analysis. Note that we
require genes to be expressed in at least 25% of cells within each
cell type and the genes to have high allelic imbalance variation
across cell types. The following code chunk is recommended (not
evaluated here though). If users want to estimate homogeneous cell
type allelic imbalance, they can set `sd = 0` and examine the below
summary step to find interesting gene clusters with weighted mean
deviating from 0.5.

```{r, eval=FALSE}
featureQCmetric <- featureQC(sce)
keep_feature <- (featureQCmetric$filter_celltype &
  featureQCmetric$filter_sd &
  featureQCmetric$filter_spike)
sce <- sce[keep_feature, ]
```

# Gene clustering

*airpart* provides a function to cluster genes by their allelic
imbalance profile across cells (not using cell grouping information,
e.g. `sce$x`). We then recommend providing genes
within a cluster to the partition function. Clustering genes increases
power for detecting cell type partitions, and improves speed as it
reduces the number of times the partition must be estimated.

We provide two methods for gene clustering. 

1. Gaussian Mixture modeling

Gaussian mixture modeling is the default method for gene
clustering. The scatter plot is shown based on top 2 PCs of the
smoothed allelic ratio data. The argument `plot=FALSE` can be used to
avoid showing the plot.

```{r}
sce <- geneCluster(sce, G = 1:4)
metadata(sce)$geneCluster
```

2. Hierarchical clustering 

```{r}
sce.hc <- geneCluster(sce, method = "hierarchical")
metadata(sce.hc)$geneCluster
```

In this simulated dataset case, the clustering is very similar, but on
allelic scRNA-seq datasets, we have found improved clustering with the
Gaussian mixture model approach (more similar genes within cluster,
based on visual inspection of PCA plot and of allelic ratio heatmaps).

# Running airpart for allelic imbalance across groups of cells

## Simple summary table of allelic ratio

We first quickly look at the weighted mean of allelic ratio for each
gene cluster. From this step we will identify the interesting gene
clusters. The mean is calculated, weighting the information from each
gene x cell element of the matrices by the total count.

```{r}
summary <- summaryAllelicRatio(sce)
summary
```

The following step is a complement of the QC on genes step. We
recommend users only run *airpart* when the largest ordered allelic
ratio difference > 0.05 for speed concerns. We find that the allelic
ratio of most of the gene clusters in such cases (small absolute
allelic ratio differences) won't provide enough evidence to detect
differential allelic imbalance.

```{r}
sapply(1:length(summary), function(i) {
  inst <- summary[[i]]
  inst_order <- inst[order(inst$weighted.mean), ]
  max(diff(inst_order$weighted.mean)) > 0.05
})
```

## Experiment-wide beta-binomial over-dispersion

We recommend examining the experiment-wide beta-binomial
over-dispersion, which helps to inform whether to use a binomial
likelihood or a nonparametric approach to partitioning the cell types
by allelic imbalance.

We focus on the first gene cluster (if a gene cluster is not provided,
`estDisp` will choose the largest cluster).

The blue trend line gives the typical values of over-dispersion across
all the genes in the cluster, and across all the cell types
(accounting for differences across the cell types in the expected
ratio).

```{r}
estDisp(sce, genecluster = 1)
```

## Modeling using fused lasso with binomial likelihood

*airpart* offers a method for partitioning cell types using the
generalized fused lasso with binomial likelihood, as implemented in
the *smurf* package. Cell types are merged based on their similarity
of allelic ratios, accounting for excess variance on the ratio from
low counts. The penalization is determined using deviance on held-out
data, with a 1 SE cross-validation rule for favoring smaller models
(more fused cell types).

The fusion step can also taken into account both cell-level and
gene-level baseline effects, through the use of a `formula` 
(see `?fusedLasso` for example).

```{r}
sce_sub <- fusedLasso(sce,
  model = "binomial",
  genecluster = 1, ncores = 1,
  niter = 2
)
```

The partition groups and the penalty $\lambda$ from the fused lasso
are stored in the metadata: 

```{r, results="asis"}
knitr::kable(metadata(sce_sub)$partition, row.names = FALSE)
```

```{r}
metadata(sce_sub)$lambda
```

Above, `ncores` is the number of CPU used for parallelization. As a
guide, one can specify `niter=5` when the `cts` weighted allelic ratio
difference is smaller than 0.1, in order to provide additional
estimator robustness.

### Consensus partition

If you run `niter` > 1, you can use our consensus partition function
to derive the final partition. This function makes use of ensemble
consensus clustering via the *clue* package.

```{r, results='asis', collapse=TRUE}
sce_sub <- consensusPart(sce_sub)
knitr::kable(metadata(sce_sub)$partition, row.names = FALSE)
```

## Modeling using pairwise Mann-Whitney-Wilcoxon extension

An alternative to the fused lasso with binomial likelihood is an
extension we have implemented wherein all pairs cell types are
compared with Mann-Whitney-Wilcoxon rank sum tests. In practice, we
find that when the allelic counts deviates strongly from a binomial
(e.g. large over-dispersion, small values of `theta`), the `wilcoxExt`
function can offer improved performance, in terms of recovery of the
true partition of cell types by allelic imbalance. The partition is
decided based on a loss function motivated by the Bayesian Information
Criteria.

```{r}
thrs <- 10^seq(from = -2, to = -0.4, by = 0.2)
sce_sub_w <- wilcoxExt(sce, genecluster = 1, threshold = thrs)
knitr::kable(metadata(sce_sub_w)$partition, row.names = FALSE)
metadata(sce_sub_w)$threshold
```

## Calculating allelic ratio estimates via beta-binomial model

After *airpart* determines a partition of cell types either by the fused
lasso with binomial likelihood or the nonparametric approach described
above, it uses those fused lasso estimates or weighted means as the
center of a Cauchy prior for posterior estimation of allelic ratios
per cell type and per gene. Posterior mean and credible intervals are
provided. The posterior inference makes use of a beta-binomial
likelihood, and a moderated estimate of the over-dispersion. The prior
from the partition and the moderated estimate of over-dispersion are
provided to the `apeglm` function from the Bioconductor package of the
same name.

Note that the estimates and credible intervals are not equal for cell
types in the same partition and for genes, because in this step we
re-estimate the conditional cell type means per cell type (not per
partition) and account for each gene's moderated estimate of
over-dispersion.

```{r, warning=FALSE, fig.width=12}
sce_sub <- allelicRatio(sce_sub, DAItest = TRUE)
makeForest(sce_sub, showtext = TRUE)
```

Allelic ratio estimates (`ar`) as well as `svalue` and credible
interval (`lower` and `upper`) are stored in `rowData`. Can use `extractResult` function to derive them.

```{r results="asis"}
genepoi <- paste0("gene", seq_len(5))
ar <- extractResult(sce_sub)
knitr::kable(ar[genepoi,])
makeStep(sce_sub[genepoi,])
```

### Derive statistical inference

To derive statistical inference of allelic imbalance(AI), we suggest a low aggregate probability of false-sign-or-small (FSOS) events (s-value < .005) or examine credible intervals not overlapping an allelic ratio of 0.5. Here all selected 5 genes demonstrated AI on each cell type. 


```{r}
s <- extractResult(sce_sub, "svalue")
apply(s[genepoi,],2, function(s){s<0.005})
```

To derive statistical inference of dynamic AI(DAI), raw p values from likelihood ratio test(LRT) and Benjamini-Hochberg (BH) corrected p value are stored in `p.value` and `adj.p.value`, respectively. Here all 25 genes demonstrated DAI across cells. 

```{r}
adj.p <- mcols(sce_sub)$adj.p.value
adj.p < 0.05
```


# Allelic ratio partition and posterior inference, example II

To demonstrate showing partition results on a heatmap, let's make a
more complex simulation, with 8 cell types, in 3 true groups
by allelic ratio. In the code below, we construct the more complex
simulation, run preprocessing, and examine the allelic ratio heatmap.

```{r}
nct <- 8
p.vec <- (rep(c(
  -3, 0, -3, 3,
  rep(0, nct / 2),
  2, 3, 4, 2
), each = 2) + 5) / 10
sce <- makeSimulatedData(
  mu1 = 2, mu2 = 10, nct = nct, n = 30,
  ngenecl = 50, theta = 20, ncl = 3, p.vec = p.vec
)
sce <- preprocess(sce)

cellQCmetrics <- cellQC(sce, mad_detected = 4)
keep_cell <- (
  cellQCmetrics$filter_sum | # sufficient features (genes)
    cellQCmetrics$filter_detected | # sufficient molecules counted
    # sufficient features expressed compared to spike genes,
    # high quality cells
    cellQCmetrics$filter_spike
)
sce <- sce[, keep_cell]

featureQCmetric <- featureQC(sce)
keep_feature <- (featureQCmetric$filter_celltype &
  featureQCmetric$filter_sd &
  featureQCmetric$filter_spike)
sce <- sce[keep_feature, ]

makeHeatmap(sce)
```

We can then perform gene clustering:

```{r}
sce <- geneCluster(sce, G = 1:4)
table(mcols(sce)$cluster)
```

We check for experiment-wide beta-binomial over-dispersion.
Note that larger `theta` (y-axis) corresponds to *less*
over-dispersion. 

We focus on the first gene cluster (if a gene cluster is not provided,
`estDisp` will choose the largest cluster).

```{r}
estDisp(sce, genecluster = 1)
```

We identify an interesting gene cluster and run the fused lasso.

```{r}
sce_sub <- fusedLasso(sce,
  model = "binomial",
  genecluster = 1, ncores = 1
)
```

```{r, results="asis"}
knitr::kable(metadata(sce_sub)$partition, row.names = FALSE)
```

Next we estimate allelic ratios per cell type and per gene, with
credible intervals. For demonstration, we subset to the first 10
genes. 

```{r}
sce_sub2 <- sce_sub[1:10, ]
sce_sub2 <- allelicRatio(sce_sub2)
```

We plot all cell types together, but one can set `ctpoi=c(1,3,7)` to
limit the cell types to be plotted when there are too many cell
types. And one can set `genepoi=c(1,3,7)` or `genepoi=c("gene1","gene3","gene7")` 
to only plot selected genes.


```{r}
makeForest(sce_sub2)
ar <- extractResult(sce_sub2)
knitr::kable(ar)
```

A violin plot with posterior mean allelic ratios (one estimate per
gene) on the y-axis:

```{r}
makeViolin(sce_sub2)
```

Finally, a heatmap as before, but now with the cell types grouped
according to the partition:

```{r}
makeHeatmap(sce_sub2)
```

The heatmap can also be shown ordered by cell type.

```{r}
makeHeatmap(sce_sub2, order_by_group = FALSE)
```

# Session Info

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fusedLasso.R
\name{fusedLasso}
\alias{fusedLasso}
\title{Generalized fused lasso to partition cell types by allelic imbalance}
\usage{
fusedLasso(
  sce,
  formula,
  model = c("binomial", "gaussian"),
  genecluster,
  niter = 1,
  pen.weights,
  lambda = "cv1se.dev",
  k = 5,
  adj.matrix,
  lambda.length = 25L,
  se.rule.nct = 8,
  se.rule.mult = 0.5,
  ...
)
}
\arguments{
\item{sce}{A SingleCellExperiment containing assays (\code{"ratio"},
\code{"counts"}) and colData \code{"x"}}

\item{formula}{A \code{\link[stats]{formula}} object which will typically
involve a fused lasso penalty: default is just using cell-type `x`:
\code{ratio ~ p(x, pen="gflasso")}. Other possibilities would be to use
the Graph-Guided Fused Lasso penalty, or add covariates want to be
adjusted for, which can include a gene-level baseline `gene`
\code{ratio ~ p(x, pen = "ggflasso") + gene + batch}
See \code{\link[smurf]{glmsmurf}} for more details}

\item{model}{Either \code{"binomial"} or \code{"gaussian"} used to fit
the generalized fused lasso}

\item{genecluster}{which gene cluster to run the fused lasso on.
Usually one first identifies an interesting gene cluster pattern by
\code{\link{summaryAllelicRatio}}}

\item{niter}{number of iterations to run; recommended to run 5 times
if allelic ratio differences across cell types are within [0.05, 0.1]}

\item{pen.weights}{argument as described in \code{\link[smurf]{glmsmurf}}}

\item{lambda}{argument as described in \code{\link[smurf]{glmsmurf}}.
Default lambda is determined by \code{"cv1se.dev"}
(cross-validation within 1 standard error rule(SE); deviance)}

\item{k}{number of cross-validation folds}

\item{adj.matrix}{argument as described in \code{\link[smurf]{glmsmurf}}}

\item{lambda.length}{argument as described in \code{\link[smurf]{glmsmurf}}}

\item{se.rule.nct}{the number of cell types to trigger a different SE-based rule than 1 SE
(to prioritize larger models, less fusing,
good for detecting smaller, e.g. 0.05, allelic ratio differences).
When the number of cell types is less than or equal to this value,
\code{se.rule.mult} SE rule is used. When the number of cell types
is larger than this value, the standard 1 SE rule is used.}

\item{se.rule.mult}{the multiplier of the SE in determining the lambda:
the chosen lambda is within \code{se.rule.mult} x SE of the minimum deviance.
Small values will prioritize larger models, less fusing.
Only used when number of cell types is equal to or less than \code{se.rule.nct}}

\item{...}{additional arguments passed to \code{\link[smurf]{glmsmurf}}}
}
\value{
A SummarizedExperiment with attached metadata and colData:
a matrix grouping factor partition
and the penalized parameter lambda
are returned in metadata \code{"partition"} and \code{"lambda"}.
Partition and logistic group allelic estimates are stored in
colData: \code{"part"} and \code{"coef"}.
}
\description{
Fits generalized fused lasso with either binomial(link="logit")
or Gaussian likelihood, leveraging functions from the
\code{smurf} package.
}
\details{
Usually, we used a Generalized Fused Lasso penalty for the
cell states in order to regularize all possible coefficient differences.
Another possibility would be to use the Graph-Guided Fused Lasso penalty
to only regularize the differences of coefficients of neighboring
cell states.

When using a Graph-Guided Fused Lasso penalty, the adjacency matrix
corresponding to the graph needs to be provided. The elements of this
matrix are zero when two levels are not connected, and one when they are
adjacent.

See the package vignette for more details and a complete description of a
use case.
}
\examples{
library(S4Vectors)
library(smurf)
sce <- makeSimulatedData()
sce <- preprocess(sce)
sce <- geneCluster(sce, G = seq_len(4))
f <- ratio ~ p(x, pen = "gflasso") # formula for the GFL
sce_sub <- fusedLasso(sce,
  formula = f, model = "binomial", genecluster = 1, ncores = 1)
metadata(sce_sub)$partition
metadata(sce_sub)$lambda

# can add covariates or `gene` to the formula
f2 <- ratio ~ p(x, pen = "gflasso") + gene
sce_sub <- fusedLasso(sce[1:5,],
  formula = f2, model = "binomial",
  genecluster = 1, ncores = 1)

# Suppose we have 4 cell states, if we only want neibouring cell states
# to be grouped together with other cell states. Note here the names of
# the cell states should be given as row and column names.
nct <- nlevels(sce$x)
adjmatrix <- makeOffByOneAdjMat(nct)
colnames(adjmatrix) <- rownames(adjmatrix) <- levels(sce$x)
f <- ratio ~ p(x, pen = "ggflasso") # use graph-guided fused lasso
sce_sub <- fusedLasso(sce,
  formula = f, model = "binomial", genecluster = 1,
  lambda = 0.5, ncores = 1,
  adj.matrix = list(x = adjmatrix)
)
metadata(sce_sub)$partition
}
\references{
This function leverages the glmsmurf function from the smurf package.
For more details see the following manuscript:

Devriendt S, Antonio K, Reynkens T, et al.
Sparse regression with multi-type regularized feature modeling[J].
Insurance: Mathematics and Economics, 2021, 96: 248-261.
}
\seealso{
\code{\link[smurf]{glmsmurf}},
\code{\link[smurf]{glmsmurf.control}},
\code{\link[smurf]{p}}, \code{\link[stats]{glm}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/QC.R
\name{featureQC}
\alias{featureQC}
\title{Quality control on features}
\usage{
featureQC(sce, spike, detection_limit = 1, threshold = 0.25, sd = 0.03, pc = 2)
}
\arguments{
\item{sce}{SingleCellExperiment with \code{counts} and \code{ratio}}

\item{spike}{the character name of spike genes. The default is \code{Ercc}}

\item{detection_limit}{Numeric scalar providing the value above which
observations are deemed to be expressed.}

\item{threshold}{A numeric scalar specifying the threshold above which
percentage of cells expressed within each cell type. Default is 0.25}

\item{sd}{A numeric scalar specifying the cell type weighted
allelic ratio mean standard deviation threshold
above which are interested features with highly variation. Default is 0.03}

\item{pc}{pseudocount in the \code{preprocess} step}
}
\value{
A DataFrame of QC statistics includes
\itemize{
  \item{filter_celltype} {indicate whether genes expressed in more than
\code{threshold} cells for all cell types}
  \item{sd} {read counts standard deviation for each feature}
  \item{filter_sd} {indicate whether gene standard deviation
exceed \code{sd}}
  \item{filter_spike} {indicate no spike genes}
  }
}
\description{
Quality control on features
}
\examples{

sce <- makeSimulatedData()
sce <- preprocess(sce)
featureQCmetric <- featureQC(sce)
keep_feature <- (featureQCmetric$filter_celltype &
  featureQCmetric$filter_sd &
  featureQCmetric$filter_spike)
sce <- sce[keep_feature, ]

# or manually setting threshold
featureQCmetric <- featureQC(sce,
  spike = "Ercc",
  threshold = 0.25, sd = 0.03, pc = 2
)
keep_feature <- (featureQCmetric$filter_celltype &
  featureQCmetric$sd > 0.02)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/QC.R
\name{cellQC}
\alias{cellQC}
\title{Quality control on cells}
\usage{
cellQC(
  sce,
  spike,
  threshold = 0,
  mad_sum = 5,
  mad_detected = 3,
  mad_spikegenes = 5
)
}
\arguments{
\item{sce}{SingleCellExperiment with \code{counts} and \code{ratio}}

\item{spike}{the character name of spike genes.
If missing, \code{spikePercent} will all be zero and
\code{filter_spike} will be false.}

\item{threshold}{A numeric scalar specifying the threshold
above which a gene is considered to be detected.}

\item{mad_sum}{A numeric scalar specifying exceed
how many median absolute deviations
from the median log10-counts a cell is considered to be filtered out.
Default is 5.}

\item{mad_detected}{A numeric scalar specifying exceed
how many median absolute deviations
from the median detected features a cell is considered to be filtered out.
Default is 5.}

\item{mad_spikegenes}{A numeric scalar specifying exceed
how many median absolute deviations
from the median spike genes expression percentage a cell
is considered to be filtered out. Default is 5.}
}
\value{
A DataFrame of QC statistics includes
\itemize{
  \item{sum} {the sum of counts of each cell}
  \item{detected} {the number of features above \code{threshold}}
  \item{spikePercent} {the percentage of counts assignes to spike genes}
  \item{filter_sum} {indicate whether log10-counts
   within \code{mad_sum} median absolute deviations
from the median log10-counts for the dataset}
  \item{filter_detected} {indicate whether features detected by this cell
   within \code{mad_detected} median absolute deviations
from the median detected features for the dataset}
  \item{filter_spike} {indicate whether percentage expressed by spike genes
   within \code{mad_spikegenes} median absolute deviations from the median
   spike genes expression percentage for the dataset}
  }
}
\description{
Quality control on cells
}
\examples{
sce <- makeSimulatedData()
sce <- preprocess(sce)
cellQCmetrics <- cellQC(sce)
keep_cell <- (
  cellQCmetrics$filter_sum | # sufficient features (genes)
    # sufficient molecules counted
    cellQCmetrics$filter_detected |
    # sufficient features expressed compared to spike genes
    cellQCmetrics$filter_spike
)
sce <- sce[, keep_cell]

# or manually setting threshold
cellQCmetrics <- cellQC(sce,
  spike = "Ercc",
  mad_detected = 4, mad_spikegenes = 4
)
keep_cell <- (
  cellQCmetrics$sum > 2.4 |
    cellQCmetrics$detected > 110
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makeViolin.R
\name{makeViolin}
\alias{makeViolin}
\title{Posterior mean allelic ratio estimates in violin plots}
\usage{
makeViolin(sce, xlab = "cell type", ylim = c(0, 1))
}
\arguments{
\item{sce}{SingleCellExperiment}

\item{xlab}{the x axis name.}

\item{ylim}{the y axis range}
}
\value{
a ggplot2 object, \code{n} represents number of cells in that cell type.
}
\description{
Posterior mean allelic ratio estimates in violin plots
}
\examples{

sce <- makeSimulatedData()
sce <- preprocess(sce)
sce <- geneCluster(sce, G = 1:4)
sce_sub <- wilcoxExt(sce, genecluster = 1)
sce_sub <- allelicRatio(sce_sub)
makeViolin(sce_sub)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cluster.R
\name{geneCluster}
\alias{geneCluster}
\title{Gene clustering based on allelic ratio matrix with pseudo-count}
\usage{
geneCluster(
  sce,
  G,
  method = c("GMM", "hierarchical"),
  minClusterSize = 3,
  plot = TRUE,
  ...
)
}
\arguments{
\item{sce}{SingleCellExperiment containing assays \code{"ratio_pseudo"} and
colData factor \code{"x"}}

\item{G}{An integer vector specifying the numbers of clusters for which the
BIC is to be calculated.
 The default is G=c(8, 12, 16, 20, 24).}

\item{method}{the method to do gene clustering. The default is the Gaussian
Mixture Modeling which
is likely to be more accurate. \code{"hierarchical"} represents
automatic hierarchical clustering which is faster to compute.}

\item{minClusterSize}{Minimum cluster size of \code{"hierarchical"} method.}

\item{plot}{logical, whether to make a PCA plot}

\item{...}{Catches unused arguments in indirect or list calls via do.call
as described in \code{\link[mclust]{Mclust}}}
}
\value{
gene cluster IDs are stored in the rowData column \code{cluster}
and a table of gene cluster is returned in metadata \code{geneCluster}
}
\description{
Gene clustering based on allelic ratio matrix with pseudo-count
}
\examples{

sce <- makeSimulatedData()
sce <- preprocess(sce)
sce <- geneCluster(sce, G = seq_len(4))
}
\references{
This function leverages Mclust from the mclust package, or hclust.

For mclust see:
Luca Scrucca and Michael Fop and T. Brendan Murphy, Adrian E. Raftery
"mclust 5: clustering, classification and density
estimation using {G}aussian finite mixture models"
2016. The R Journal. doi: 10.32614/RJ-2016-021
}
\seealso{
\code{\link[mclust]{Mclust}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fitBB.R
\name{allelicRatio}
\alias{allelicRatio}
\title{Fit beta-binomial across cell types}
\usage{
allelicRatio(sce, formula, nogroup = FALSE, level = 0.95, DAItest = FALSE, ...)
}
\arguments{
\item{sce}{A SingleCellExperiment containing assays
(\code{"ratio"}, \code{"counts"}) and colData (\code{"x"},
\code{"part"})}

\item{formula}{The same \code{\link[stats]{formula}} object
used in \code{\link[airpart]{fusedLasso}} or used in \code{\link[splines]{ns}}
when want to detect smooth continuous-axis estimates. eg. formula <- ratio ~ ns(x, df = 5)}

\item{nogroup}{Indicate whether there is previous group step. Default is FALSE represents either
Generalized fused lasso or nonparametric method is used to derive partition. nogroup == TRUE means
the hypothesis that groups of cell types sharing a common regulatory context is not valid}

\item{level}{the level of credible interval (default is 0.95)}

\item{DAItest}{Indicate whether to do Likelihood Ratio test on differential allelic imbalance(DAI)
or equivalent to heterogeneity.}

\item{...}{arguments to pass to \code{\link[apeglm]{apeglm}}
functions}
}
\value{
posterior mean (\code{"ar"}) for allelic ratio
estimate is returned in the rowData for each cell type,
as well as the \code{"s"} value, \code{"fsr"} false sign rate and
credible interval (\code{"lower"} and \code{"upper"}). One can use \code{"fsr"} < 0.005 or
credible intervals contain 0.5 or not for AI test significance. \code{"p.value"} shows DAI test result
and \code{"adj.p.value"} is false discovery rate corrected p values.
}
\description{
This function performs additional inference on the allelic ratio
across cell types, giving posterior mean and credible
intervals per cell type. A Cauchy prior is centered for
each cell type on the allelic ratio from the fused lasso
across all genes in the gene cluster
(or using a weighted means if the fused lasso is not provided).
}
\examples{

sce <- makeSimulatedData()
sce <- preprocess(sce)
sce <- geneCluster(sce, G = seq_len(4))
sce_sub <- wilcoxExt(sce, genecluster = 1)
sce_sub <- allelicRatio(sce_sub, DAItest = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/consensusPart.R
\name{consensusPart}
\alias{consensusPart}
\title{Consensus Partitions}
\usage{
consensusPart(sce)
}
\arguments{
\item{sce}{SingleCellExperiment}
}
\value{
A matrix grouping factor partition is replaced in metadata.
Consensus Partation also stored in colData\code{"part"}.
}
\description{
Derive consensus partitions of an ensemble fused lasso partitions.
}
\examples{
library(smurf)
sce <- makeSimulatedData()
sce <- preprocess(sce)
sce <- geneCluster(sce, G = 1:4)
f <- ratio ~ p(x, pen = "gflasso") # formula for the GFL
sce_sub <- fusedLasso(sce,
  formula = f, model = "binomial", genecluster = 1,
  niter = 2, ncores = 2, se.rule.nct = 3
)
sce_sub <- consensusPart(sce_sub)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fusedLasso.R
\name{makeOffByOneAdjMat}
\alias{makeOffByOneAdjMat}
\title{Generating adjancy matrix for neighboring cell states.}
\usage{
makeOffByOneAdjMat(nct)
}
\arguments{
\item{nct}{the number of cell types/states}
}
\description{
To use the Graph-Guided Fused Lasso penalty to only regularize the differences
of coefficients of neighboring areas, suitable for time/spatial analysis.
The adjacency matrix corresponding to the graph needs to be provided.
The elements of this matrix are zero when two levels are not connected, and one when they are adjacent.
}
\details{
If manually input the adjacency matrix, this matrix has to be symmetric and the names of
the cell states should be given as row and column names.
}
\examples{
sce <- makeSimulatedData()
nct <- nlevels(sce$x)
adjmatrix <- makeOffByOneAdjMat(nct)
colnames(adjmatrix) <- rownames(adjmatrix) <- levels(sce$x)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makeHeatmap.R
\name{makeHeatmap}
\alias{makeHeatmap}
\title{Plot allelic ratio as heatmap}
\usage{
makeHeatmap(
  sce,
  assay = c("ratio_pseudo", "ratio", "counts"),
  genecluster = NULL,
  show_row_names = FALSE,
  order_by_group = TRUE,
  ...
)
}
\arguments{
\item{sce}{SingleCellExperiment}

\item{assay}{the assay to be plotted. Choices are \code{"ratio_pseudo"} which is the default,
\code{"ratio"}, \code{"counts"}.}

\item{genecluster}{an integer indicates which gene cluster heatmap want to be returned.}

\item{show_row_names}{show row names or not}

\item{order_by_group}{indicate whether order by group or order by cell types}

\item{...}{Passsed on the other argument in
\code{\link[ComplexHeatmap]{Heatmap}}.}
}
\value{
generates a heatmap
}
\description{
Plot allelic ratio as heatmap
}
\examples{
set.seed(2021)
sce <- makeSimulatedData(p.vec = c(0.3, 0.5, 0.5, 0.3), ncl = 1)
sce <- preprocess(sce)
# display allelic ratio pattern in whole dataset
makeHeatmap(sce)

sce <- geneCluster(sce, G = seq_len(4), plot = FALSE)
sce_sub <- wilcoxExt(sce, genecluster = 1)
# display specific gene cluster partition result
makeHeatmap(sce_sub)
# display by cell type orders
makeHeatmap(sce_sub, order_by_group = FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makeStep.R
\name{makeStep}
\alias{makeStep}
\title{Plot group partition and posterior allelic ratio estimates by step}
\usage{
makeStep(sce, xlab = "cell type")
}
\arguments{
\item{sce}{SingleCellExperiment}

\item{xlab}{the x axis name.}
}
\value{
a ggplot2 object.
}
\description{
Plot group partition and posterior allelic ratio estimates by step
}
\examples{

sce <- makeSimulatedData()
sce <- preprocess(sce)
sce <- geneCluster(sce, G = 1:4)
sce_sub <- wilcoxExt(sce, genecluster = 1)
sce_sub <- allelicRatio(sce_sub)
makeStep(sce_sub)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wilcoxon.R
\name{wilcoxExt}
\alias{wilcoxExt}
\title{Extension on Pairwise Mann Whitney Wilcoxon Test for partitioning}
\usage{
wilcoxExt(
  sce,
  genecluster,
  threshold,
  adj.matrix,
  p.adjust.method = "none",
  ncores = NULL,
  ...
)
}
\arguments{
\item{sce}{A SingleCellExperiment containing assays (\code{"ratio"},
\code{"counts"}) and colData \code{"x"}}

\item{genecluster}{which gene cluster result want to be returned.
Usually identified interesting gene cluster pattern by
\code{\link{summaryAllelicRatio}}}

\item{threshold}{a vector with candidate thresholds for raw p-value
cut-off. Default is 10^seq(from=-2,to=-0.4,by=0.2).
For details please see vignette}

\item{adj.matrix}{an adjacency matrix with 1 indicates cell states
allowed to be grouped together, 0 otherwise.}

\item{p.adjust.method}{method for adjusting p-values
(see \code{\link[stats]{p.adjust}}). Can be abbreviated}

\item{ncores}{A cluster object created by \code{\link[parallel]{makeCluster}}.
Or an integer to indicate number of child-processes
(integer values are ignored on Windows) for parallel evaluations}

\item{...}{additional arguments to pass to \code{\link[stats]{wilcox.test}}.}
}
\value{
A matrix grouping factor partition and
the significant cut-off threshold
are returned in metadata \code{"partition"} and \code{"threshold"}.
Partation also stored in colData\code{"part"}. Note we recommend the returned 
\code{"threshold"} is not at the ends of input \code{"threshold"}.
}
\description{
Extends the Pairwise Mann Whitney Wilcoxon Test by combining
hierarchical clustering for partition.
}
\examples{
library(S4Vectors)
sce <- makeSimulatedData()
sce <- preprocess(sce)
sce <- geneCluster(sce, G = seq_len(4))
sce_sub <- wilcoxExt(sce, genecluster = 1)
metadata(sce_sub)$partition
metadata(sce_sub)$threshold

# Suppose we have 4 cell states, if we don't want cell state 1
# to be grouped together with other cell states
adj.matrix <- 1 - diag(4)
colnames(adj.matrix) <- rownames(adj.matrix) <- levels(sce$x)
adj.matrix[1, c(2, 3, 4)] <- 0
adj.matrix[c(2, 3, 4), 1] <- 0
thrs <- 10^seq(from = -2, to = -0.4, by = 0.1)
sce_sub <- wilcoxExt(sce,
  genecluster = 1, threshold = thrs,
  adj.matrix = adj.matrix
)
metadata(sce_sub)$partition
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summary.R
\name{summaryAllelicRatio}
\alias{summaryAllelicRatio}
\title{Allelic ratio summary}
\usage{
summaryAllelicRatio(sce, genecluster)
}
\arguments{
\item{sce}{SingleCellExperiment}

\item{genecluster}{an optional vector of gene cluster IDs.
if nothing is given, all cluster's summaries will be
calculated}
}
\value{
a list of gene cluster summary tables containing:
\itemize{
  \item{weighted.mean} {weighted mean of allelic ratio for the cell types}
  \item{mean} {mean allelic ratio for the cell types}
  \item{var} {variance of allelic ratio for the cell types}
}
}
\description{
Oroduce allelic ratio summaries for each gene cluster
}
\examples{

library(S4Vectors)
sce <- makeSimulatedData()
sce <- preprocess(sce)
sce <- geneCluster(sce, G = 1:4)
summary <- summaryAllelicRatio(sce, genecluster = c(1, 3))
summary
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extractResult.R
\name{extractResult}
\alias{extractResult}
\title{Extract results from an airpart analysis}
\usage{
extractResult(sce, estimates = c("ar", "svalue", "fsr", "lower", "upper"))
}
\arguments{
\item{sce}{SingleCellExperiment}

\item{estimates}{the estimates want to be extracted. Default is allelic ratio estimates,
can be \code{"svalue"}, \code{"fsr"}, \code{"lower"}(credible interval) and \code{"upper"}(credible interval)}
}
\value{
a DataFrame of estimates
}
\description{
results extracts a result table from an airpart analysis giving posterior allelic ratio estimates,
s values, false sign rate(fsr), upper confidence interval and lower confidence interval.
}
\examples{

sce <- makeSimulatedData()
sce <- preprocess(sce)
sce <- geneCluster(sce, G = 1:4)
sce_sub <- wilcoxExt(sce, genecluster = 1)
sce_sub <- allelicRatio(sce_sub)
ar <- extractResult(sce_sub)
ar
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/estDisp.R
\name{estDisp}
\alias{estDisp}
\title{Estimate overdispersion parameter of a beta-binomial}
\usage{
estDisp(sce, genecluster, type = c("plot", "values"))
}
\arguments{
\item{sce}{SingleCellExperiment with \code{a1} matrix and \code{counts}}

\item{genecluster}{the gene cluster for which to estimate the
over-dispersion parameter. Default is the cluster with the most cells}

\item{type}{whether to output the over-dispersion estimates as a plot or a value}
}
\value{
A ggplot object of the dispersion estimates over the mean,
or a data.frame of the mean and dispersion estimates (theta)
}
\description{
Estimate overdispersion parameter of a beta-binomial
}
\examples{

sce <- makeSimulatedData()
sce <- preprocess(sce)
sce <- geneCluster(sce, G = seq_len(4))
estDisp(sce, genecluster = 1)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makeSimulatedData.R
\name{makeSimulatedData}
\alias{makeSimulatedData}
\title{Make simulated data for airpart}
\usage{
makeSimulatedData(
  mu1 = 2,
  mu2 = 10,
  nct = 4,
  n = 30,
  ngenecl = 50,
  theta = 20,
  ncl = 3,
  p.vec = rep(c(0.2, 0.8, 0.5, 0.5, 0.7, 0.9), each = 2),
  totalClusters = FALSE
)
}
\arguments{
\item{mu1}{low count (typical of "noisy" ratio estimates)}

\item{mu2}{high count}

\item{nct}{number of cell types}

\item{n}{number of cells per cell type}

\item{ngenecl}{number of genes per cluster}

\item{theta}{overdispersion parameter (higher is closer to binomial)}

\item{ncl}{number of gene cluster}

\item{p.vec}{the allelic ratio vector which follows gene cluster order.
(length is nct * ncl)}

\item{totalClusters}{logical, whether cell types should cluster by total
count}
}
\value{
SingleCellExperiment with the following elements as assays
\itemize{
  \item{a1} {allelic count matrix for the numerator/effect allele}
  \item{a2} {allelic count matrix for the denominator/non-effect allele}
  \item{true.ratio} {a matrix of the true probabilities
(allelic ratios) for the cell types}
}
Also \code{x} in the colData is a vector of annotated
cell types in the same order as cells in count matrix
}
\description{
Make simulated data for airpart
}
\examples{
library(SummarizedExperiment)
sce <- makeSimulatedData()
assayNames(sce)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makeForest.R
\name{makeForest}
\alias{makeForest}
\title{Plot allelic ratio result as forest}
\usage{
makeForest(
  sce,
  genepoi,
  ctpoi = seq_len(nlevels(sce$x)),
  showtext = FALSE,
  xticks,
  boxsize = 0.25,
  xlab = "Allelic Ratio",
  col,
  grid = structure(seq(0.1, 0.9, 0.1), gp = gpar(lty = 2, col = "#CCCCFF")),
  ...
)
}
\arguments{
\item{sce}{A SingleCellExperiment containing colData
allelic ratio estimator in the third column
and last two column is the confidence interval.}

\item{genepoi}{the gene position index or gene name vector that want to be plotted.
Ordered by increased cell type svalue.
Default is the top 40 genes that has minimum svalue in any cell type
or all genes if number of genes smaller than 40.}

\item{ctpoi}{the cell type position index that want to be plotted.}

\item{showtext}{indicate whether show the svalue information along the forestplot.}

\item{xticks}{argument as described in \code{\link[forestplot]{forestplot}}}

\item{boxsize}{Override the default box size based on precision}

\item{xlab}{x-axis label. Default is "Allelic Ratio"}

\item{col}{Set the colors for all the elements. See
\code{\link[forestplot]{fpColors}} for details}

\item{grid}{If you want a discrete gray dashed grid
at the level of the ticks
you can set this parameter to TRUE.
If you set the parameter to a vector of values lines will be drawn at the
corresponding positions.
If you want to specify the \code{\link[grid]{gpar}} of the lines
then either directly pass a \code{\link[grid]{gpar}} object
or set the gp attribute e.g.
\code{attr(line_vector, "gp") <- }
\code{\link[grid]{gpar}}\code{(lty=2, col = "red")}}

\item{...}{Passsed on the other argument in
\code{\link[forestplot]{forestplot}}.}
}
\value{
generates a forest plot
}
\description{
Draw a forest plot to visualized cell type specific
allelic ratio estimator and confidence interval.
It is based on the \pkg{forestplot}-package`s \code{forestplot} function.
}
\examples{
sce <- makeSimulatedData()
sce <- preprocess(sce)
sce <- geneCluster(sce, G = 1:4)
sce_sub <- wilcoxExt(sce, genecluster = 1)
sce_sub <- allelicRatio(sce_sub)
makeForest(sce_sub, showtext = TRUE)

# if want to change some properties, like ticks position
library(forestplot)
xticks <- seq(from = 0, to = 1, by = 0.25)
xtlab <- rep(c(TRUE, FALSE), length.out = length(xticks))
attr(xticks, "labels") <- xtlab
genepoi <- paste0("gene", seq_len(5))
ctpoi <- c(1, 3)
makeForest(sce_sub, genepoi, ctpoi,
  xticks = xticks,
  col = fpColors(box = c("blue", "red", "black", "darkgreen"))
)
}
\seealso{
\code{\link[forestplot]{forestplot}},
\code{\link[forestplot]{fpColors}},
\code{\link[forestplot]{fpShapesGp}}, \code{\link[forestplot]{fpLegend}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocess.R
\name{preprocess}
\alias{preprocess}
\title{Preprocess the SingleCellExperiment}
\usage{
preprocess(sce, pc = 2)
}
\arguments{
\item{sce}{SingleCellExperiment with \code{a1} (effect allele)
and \code{a2} (non-effect allele). The allelic ratio will be
calculated as a1 / (a1 + a2).}

\item{pc}{pseudocount for calculating the smoothed ratio}
}
\value{
SingleCellExperiment with total count,
allelic ratio = a1/(a1 + a2), and pseud-ocount-smoothed ratio
}
\description{
Preprocess the SingleCellExperiment
}
\examples{
library(SummarizedExperiment)
sce <- makeSimulatedData()
sce <- preprocess(sce)
assayNames(sce)
}
